#include <arch_helpers.h>
#include <arch.h>
#include <bakery_lock.h>
#include <debug.h>
#include <mmio.h>
#include <mt_spm.h>
#include <mt_spm_dpidle.h>
#include <mt_spm_sodi.h>
#include <mt_spm_idle.h>
#include <mt_spm_internal.h>
#include <mt_spm_reg.h>
#include <mt_spm_pmic_wrap.h>
#include <plat_pm.h>
#include <platform_def.h>
#include <plat_private.h>
#include <scu.h>
#include <stddef.h>
#include <stdio.h>
#include <string.h>
#include <mtk_plat_common.h>
#include <mtk_gic.h>

#include <lib/xlat_tables/xlat_tables_defs.h>
#include <lib/xlat_tables/xlat_tables_v2.h>

#define DRAMC_REG_ARBCTL	0x1022c010

/*
 * System Power Manager (SPM) is a hardware module, which controls cpu or
 * system power for different power scenarios using different firmware, i.e.,
 * - spm_hotplug.c for cpu power control in cpu hotplug flow.
 * - spm_mcdi.c for cpu power control in cpu idle power saving state.
 * - spm_suspend.c for system power control in system suspend scenario.
 *
 * This file provide utility functions common to hotplug, mcdi(idle), suspend
 * power scenarios. A bakery lock (software lock) is incoporated to protect
 * certain critical sections to avoid kicking different SPM firmware
 * concurrently.
 */

DEFINE_BAKERY_LOCK(spm_lock);


static const uint32_t suspend_binary[] = {
	0xa1d58407, 0xa1d70407, 0x81f68407, 0xa1d28407, 0x81f20407, 0x80318400,
	0x81f88407, 0x81f00407, 0x81fd0407, 0xc280b0e0, 0x1290041f, 0xa19d8406,
	0xa1dc0407, 0x1b00001f, 0x00000006, 0xf0000000, 0x17c07c1f, 0x1910001f,
	0x10006600, 0x81259001, 0x81431801, 0xd8000305, 0x17c07c1f, 0xa0118400,
	0x81bd8406, 0xa1d88407, 0x1b80001f, 0x20000014, 0xa1dc0407, 0x1b00001f,
	0x00000001, 0xa1d20407, 0x81f28407, 0xa1d68407, 0x81f70407, 0x81f59007,
	0xf0000000, 0x17c07c1f, 0x814a1801, 0xd8000645, 0x17c07c1f, 0xa1d58407,
	0xa1d70407, 0x81f68407, 0x1a50001f, 0x10006150, 0x803a0400, 0x1b80001f,
	0x20000000, 0x80300400, 0x80328400, 0x814a1801, 0xd8000945, 0x17c07c1f,
	0xa1d28407, 0x81f20407, 0x814a9801, 0xd80008c5, 0x17c07c1f, 0x18c0001f,
	0x10006634, 0x19300003, 0x17c07c1f, 0x02a01009, 0x18c0001f, 0x10006630,
	0x19700003, 0x17c07c1f, 0x0240140a, 0xe0c00009, 0x81f88407, 0xe8208000,
	0x10006614, 0x20000000, 0x81431801, 0xd80009c5, 0x17c07c1f, 0x80318400,
	0x814a1801, 0xd8200b25, 0x17c07c1f, 0x1a00001f, 0x10006700, 0xe2200006,
	0xc0c0b1e0, 0x17c07c1f, 0xe8208000, 0x1000660c, 0x00000006, 0x814a1801,
	0xd8000e45, 0x17c07c1f, 0x814a1801, 0x1880001f, 0x10006028, 0xe080000f,
	0xc0c0ac80, 0x17c07c1f, 0xd8000ce3, 0x17c07c1f, 0x1880001f, 0x10006028,
	0xe080001f, 0xc0c0aa80, 0x11407c1f, 0x814a1801, 0xa1dd0407, 0x81f00407,
	0x18d0001f, 0x10006164, 0x80df0403, 0xd8200d83, 0x17c07c1f, 0x81fd0407,
	0x18c0001f, 0x10006604, 0x1910001f, 0x10006604, 0x80899801, 0x813f8804,
	0x808a1801, 0x813f0804, 0x808a9801, 0x813e0804, 0xe0c00004, 0x808a1801,
	0xcaa0b0e2, 0x1290041f, 0xa19d8406, 0xa1dc0407, 0x1b00001f, 0x00000006,
	0xf0000000, 0x17c07c1f, 0x81fc0407, 0x1b00001f, 0xbfffffff, 0x81fc8407,
	0x1b80001f, 0x20000004, 0x88c0000c, 0xbfffffff, 0xd82012a3, 0x17c07c1f,
	0xa1dc0407, 0x1b00001f, 0x00000000, 0xd0002100, 0x17c07c1f, 0xa1dc0407,
	0x1b10001f, 0x10006148, 0x1b80001f, 0x20000004, 0xa1dc8407, 0x80d0840c,
	0xd8001443, 0x17c07c1f, 0x1b10001f, 0x10006148, 0xd0002100, 0x17c07c1f,
	0x814a1801, 0xd80017c5, 0x17c07c1f, 0xe8208000, 0x10006614, 0x10000000,
	0x1b80001f, 0x20000666, 0x1a40001f, 0x10006028, 0xe240000f, 0xc0c0ac80,
	0x17c07c1f, 0xd8201683, 0x17c07c1f, 0x814a1801, 0xd0002100, 0x17c07c1f,
	0x1a40001f, 0x10006028, 0xe240001f, 0x814a1801, 0xc0c0aa80, 0x1140041f,
	0x814a1801, 0x1b80001f, 0x200009c4, 0x81f00407, 0x814a1801, 0xd8201925,
	0x17c07c1f, 0x1a00001f, 0x10006700, 0xe2200007, 0xc0c0b1e0, 0x17c07c1f,
	0xe8208000, 0x1000660c, 0x00000007, 0x1910001f, 0x10006600, 0x82259001,
	0x81431801, 0xd8001a05, 0x17c07c1f, 0xa0118400, 0x81bd8406, 0xa0128400,
	0xa1dc0407, 0x1b00001f, 0x00000001, 0x808a1801, 0xcaa0b0e2, 0x1290841f,
	0x80899801, 0xc280b0e0, 0x129f881f, 0x808a1801, 0xc280b0e0, 0x129f081f,
	0x808a9801, 0xc280b0e0, 0x129e081f, 0x814a1801, 0xd8002105, 0x17c07c1f,
	0xa1d88407, 0x1b80001f, 0x20000014, 0x1950001f, 0x10006610, 0x81499401,
	0xd8001f45, 0x17c07c1f, 0x814a9801, 0xd8001e85, 0x17c07c1f, 0x18c0001f,
	0x10006634, 0x1910001f, 0x10006150, 0xe0c00004, 0x1950001f, 0x10006610,
	0x81691401, 0xa1d20407, 0x81f28407, 0xa1d68407, 0xa0101400, 0x1950001f,
	0x10006610, 0x814a1401, 0xd8002025, 0x17c07c1f, 0xa01a0400, 0x1950001f,
	0x10006610, 0x814a9401, 0xd8002105, 0x17c07c1f, 0x81f70407, 0x81f5a007,
	0xf0000000, 0x17c07c1f, 0x814a1801, 0xb14098a1, 0xd80023a5, 0x17c07c1f,
	0x18c0001f, 0x10006318, 0xc0c091e0, 0x1200041f, 0x1b80001f, 0x2000000e,
	0xe8208000, 0x10006614, 0x40000000, 0xe8208000, 0x10006408, 0x04e01f07,
	0xe8208000, 0x1000640c, 0x071b3700, 0x1950001f, 0x10006610, 0x814b9401,
	0xd8202545, 0x17c07c1f, 0x1940001f, 0x10000204, 0x19300005, 0x17c07c1f,
	0x89000004, 0xff8fffff, 0xa11a0404, 0xe1400004, 0xe8208000, 0x10006614,
	0x00000000, 0x808a1801, 0xcaa0b0e2, 0x1291041f, 0xa19e0406, 0xa1dc0407,
	0x1b00001f, 0x00000058, 0xe8208000, 0x10006194, 0x00000001, 0xf0000000,
	0x17c07c1f, 0x1950001f, 0x10006610, 0x814b9401, 0xd8202905, 0x17c07c1f,
	0x1940001f, 0x10000204, 0x19300005, 0x17c07c1f, 0x89000004, 0xff8fffff,
	0xa11a8404, 0xe1400004, 0x19300005, 0x17c07c1f, 0x814a1801, 0xb14098a1,
	0xd8002f65, 0x17c07c1f, 0xe8208000, 0x10006194, 0x00000000, 0x18d0001f,
	0x10006610, 0x80d00c01, 0xd8002c23, 0x17c07c1f, 0xe8208000, 0x1000640c,
	0x273f37bb, 0x18d0001f, 0x1000616c, 0x88c00003, 0x273c37bb, 0x69200003,
	0x273c37bb, 0xd8202ae4, 0x17c07c1f, 0xd0002d80, 0x17c07c1f, 0xe8208000,
	0x1000640c, 0x273f37ba, 0x18d0001f, 0x1000616c, 0x88c00003, 0x273c37ba,
	0x69200003, 0x273c37ba, 0xd8202c84, 0x17c07c1f, 0xe8208000, 0x10006408,
	0x07807240, 0x18d0001f, 0x10006168, 0x88c00003, 0x07807240, 0x69200003,
	0x07807240, 0xd8202de4, 0x17c07c1f, 0x18c0001f, 0x10006318, 0xc0c096a0,
	0x17c07c1f, 0x808a1801, 0xcaa0b0e2, 0x1291841f, 0x81be0406, 0xa1dc0407,
	0x1b00001f, 0x00000006, 0xf0000000, 0x17c07c1f, 0x80cf1801, 0xc8e07ba3,
	0x17c07c1f, 0x18d0001f, 0x10006610, 0x80df0403, 0xd8003283, 0x17c07c1f,
	0x1a00001f, 0x10006700, 0xe2200001, 0xc0c0b1e0, 0x17c07c1f, 0xe2200003,
	0xc0c0b1e0, 0x17c07c1f, 0x18d0001f, 0x10006610, 0x80df8403, 0xd8003423,
	0x17c07c1f, 0x1a00001f, 0x10006700, 0xe2200002, 0xc0c0b1e0, 0x17c07c1f,
	0xe2200004, 0xc0c0b1e0, 0x17c07c1f, 0x1890001f, 0x10006658, 0x88800002,
	0x0000ffff, 0x81489801, 0xd82037c5, 0x17c07c1f, 0x89000002, 0xfffffff8,
	0x18c0001f, 0x00000002, 0x1a80001f, 0x00000004, 0xd8003944, 0x17c07c1f,
	0x89000002, 0x00000006, 0x18c0001f, 0x00000001, 0x1a80001f, 0x00000003,
	0xd8003944, 0x17c07c1f, 0x18c0001f, 0x00000000, 0x1a80001f, 0x00000003,
	0xc0c03940, 0x17c07c1f, 0x89000002, 0x00000006, 0x18c0001f, 0x00000002,
	0x1a80001f, 0x00000004, 0xd8003944, 0x17c07c1f, 0x18c0001f, 0x00000001,
	0x1a80001f, 0x00000003, 0x1a00001f, 0x10006700, 0xe2000003, 0xc0c0b1e0,
	0x17c07c1f, 0x1b80001f, 0x200004f3, 0x1950001f, 0x10006610, 0x814c9401,
	0xd8003b65, 0x17c07c1f, 0xe200000a, 0xc0c0b1e0, 0x17c07c1f, 0x1b80001f,
	0x200004f3, 0xc0c09a60, 0x17c07c1f, 0xc0c0a180, 0x17c07c1f, 0x81489801,
	0xc8c0b845, 0x17c07c1f, 0xc0c0c5c0, 0x17c07c1f, 0x814a9801, 0xd8203de5,
	0x17c07c1f, 0xe8208000, 0x10006408, 0x00000301, 0xe8208000, 0x1000640c,
	0x06003600, 0xd0003ea0, 0x17c07c1f, 0xe8208000, 0x10006408, 0x00000301,
	0xe8208000, 0x1000640c, 0x06003600, 0xa1d80407, 0xa1d18407, 0xc280b0e0,
	0x1292041f, 0xa19e8406, 0xa1dc0407, 0x1b00001f, 0x00002120, 0xe8208000,
	0x10012008, 0x00000000, 0x18c0001f, 0x10012000, 0x1910001f, 0x10012000,
	0xa1000404, 0xe0c00004, 0xf0000000, 0x17c07c1f, 0x81f80407, 0x81f18407,
	0x18d0001f, 0x10006610, 0x80dd8403, 0xd80044a3, 0x17c07c1f, 0x1b80001f,
	0x20000044, 0x18d0001f, 0x10006160, 0x80c40c01, 0xd82044a3, 0x17c07c1f,
	0x1910001f, 0x1000661c, 0x18c0001f, 0x1000661c, 0xa9000004, 0x00030000,
	0xe0c00004, 0xd00051a0, 0x17c07c1f, 0x18c0001f, 0x1000661c, 0x1910001f,
	0x1000661c, 0x81388404, 0xe0c00004, 0x18c0001f, 0x10012000, 0x1910001f,
	0x10012000, 0x81200404, 0xe0c00004, 0xe8208000, 0x1000640c, 0x070b3700,
	0x18d0001f, 0x1000616c, 0x88c00003, 0x07083700, 0x69200003, 0x07083700,
	0xd82045c4, 0x17c07c1f, 0xe8208000, 0x10006408, 0x04e01f07, 0x18d0001f,
	0x10006168, 0x88c00003, 0x04e01f07, 0x69200003, 0x04e01f07, 0xd8204724,
	0x17c07c1f, 0x1b80001f, 0x2000001a, 0x80cf9801, 0xc8e0a183, 0x17c07c1f,
	0xe8208000, 0x100066b8, 0x00000020, 0x80c93401, 0xd8204923, 0x17c07c1f,
	0xc0c0a6c0, 0x17c07c1f, 0x1a40001f, 0x10006028, 0xe240000f, 0xd8204d23,
	0x17c07c1f, 0xa1d80407, 0xa1d18407, 0xe8208000, 0x10006408, 0x00000301,
	0xe8208000, 0x1000640c, 0x06003600, 0xa1dc0407, 0x13007c1f, 0x81fc0407,
	0xe8208000, 0x10012008, 0x00000000, 0x18c0001f, 0x10012000, 0x1910001f,
	0x10012000, 0xa1000404, 0xe0c00004, 0xd0005160, 0x17c07c1f, 0x1a40001f,
	0x10006028, 0xe240001f, 0xc0c0c380, 0x17c07c1f, 0xc0c09fc0, 0x17c07c1f,
	0xc0c097c0, 0x17c07c1f, 0x18d0001f, 0x10006610, 0x80de8403, 0xd8004f83,
	0x17c07c1f, 0x1a00001f, 0x10006700, 0xe2200000, 0xc0c0b1e0, 0x17c07c1f,
	0x1a00001f, 0x10006700, 0xe2200000, 0xc0c0b1e0, 0x17c07c1f, 0xe2200003,
	0xc0c0b1e0, 0x17c07c1f, 0xc280b0e0, 0x1292841f, 0x81be8406, 0xa19f8406,
	0xa1dc0407, 0x1b00001f, 0x00000090, 0xf0000000, 0x17c07c1f, 0x80cf9801,
	0xd8005243, 0x17c07c1f, 0xc0c0a180, 0x17c07c1f, 0x1a50001f, 0x1000669c,
	0x8a400009, 0x0000ffff, 0xd8005429, 0x17c07c1f, 0xa1dc0407, 0x1890001f,
	0x10006148, 0x18c0001f, 0x00000100, 0xa0c00803, 0x13000c1f, 0xd0007b60,
	0x17c07c1f, 0x81f20407, 0x81f28407, 0x18c0001f, 0x10006604, 0x1910001f,
	0x10006604, 0x89000004, 0xc3ffffff, 0xa11e8404, 0xe0c00004, 0x1890001f,
	0x10006658, 0x88800002, 0x0000ffff, 0x42b00809, 0xa19ba806, 0x58e00009,
	0x00000004, 0x59200002, 0x00000004, 0x91601003, 0xd8206545, 0x17c07c1f,
	0x18c0001f, 0x10006604, 0x1910001f, 0x10006604, 0xa11d0404, 0xe0c00004,
	0x810b9801, 0xd8206064, 0x17c07c1f, 0x81021801, 0xd8006004, 0x17c07c1f,
	0x1290841f, 0x1a10001f, 0x100066b0, 0x81102808, 0xd8006004, 0x17c07c1f,
	0x18c0001f, 0x10006920, 0x1111041f, 0xa1108404, 0xe0c00004, 0x18c0001f,
	0x1000692c, 0xe0e00d4a, 0x18c0001f, 0x10006920, 0xe0c00001, 0x810f0001,
	0x18c0001f, 0x10006654, 0xe0c00004, 0xd8205ba4, 0x17c07c1f, 0xc0c0f420,
	0x17c07c1f, 0xc0c0dde0, 0x17c07c1f, 0xc0c0e080, 0x17c07c1f, 0xc0c0d0a0,
	0x17c07c1f, 0x1b80001f, 0x20000110, 0xc0c0d5e0, 0x17c07c1f, 0x1910001f,
	0x10006654, 0xd8205da4, 0x17c07c1f, 0xc0c0fae0, 0x17c07c1f, 0xc0c0dbc0,
	0x17c07c1f, 0x18c0001f, 0x100066b0, 0xe0c0000a, 0x18d0001f, 0x10006920,
	0x81078c01, 0xd8205f64, 0x17c07c1f, 0x18c0001f, 0x10006090, 0x1110841f,
	0xe0c00004, 0x18c0001f, 0x10006920, 0x1111041f, 0xa1108404, 0xe0c00004,
	0x810b9801, 0xd8206484, 0x17c07c1f, 0x81019801, 0xd8006424, 0x17c07c1f,
	0x1150841f, 0x1280041f, 0x1a10001f, 0x100066b4, 0x81101408, 0xd8006424,
	0x17c07c1f, 0xc0c0d0a0, 0x17c07c1f, 0xc0c0ccc0, 0x17c07c1f, 0x81009401,
	0x81012004, 0x18c0001f, 0x00000003, 0xc8c0ce44, 0x17c07c1f, 0xc0c0d5e0,
	0x17c07c1f, 0x1900001f, 0x100066b4, 0x18d0001f, 0x100066b4, 0x88c00003,
	0x00ffff00, 0xa0d01403, 0xe1000003, 0x810b9801, 0xd8205824, 0x17c07c1f,
	0x18c0001f, 0x10006604, 0x1910001f, 0x10006604, 0x813d0404, 0xe0c00004,
	0x810b9801, 0xd8206ee4, 0x17c07c1f, 0x81021801, 0xd8006e84, 0x17c07c1f,
	0x89000009, 0xfffffff0, 0x1291041f, 0xd8006764, 0x17c07c1f, 0x89000009,
	0x0000000c, 0x1290841f, 0xd8006764, 0x17c07c1f, 0x1290041f, 0x1a10001f,
	0x100066b0, 0x81102808, 0xd8006e84, 0x17c07c1f, 0x18c0001f, 0x10006920,
	0x1111041f, 0xa1108404, 0xe0c00004, 0x18c0001f, 0x1000692c, 0xe0e00d4a,
	0x18c0001f, 0x10006920, 0xe0c00001, 0x1910001f, 0x10006654, 0xd8206a24,
	0x17c07c1f, 0xc0c0f420, 0x17c07c1f, 0xc0c0dde0, 0x17c07c1f, 0xc0c0e080,
	0x17c07c1f, 0xc0c0d0a0, 0x17c07c1f, 0x1b80001f, 0x20000110, 0xc0c0d5e0,
	0x17c07c1f, 0x1910001f, 0x10006654, 0xd8206c24, 0x17c07c1f, 0xc0c0fae0,
	0x17c07c1f, 0xc0c0dbc0, 0x17c07c1f, 0x18c0001f, 0x100066b0, 0xe0c0000a,
	0x18d0001f, 0x10006920, 0x81078c01, 0xd8206de4, 0x17c07c1f, 0x18c0001f,
	0x10006090, 0x1110841f, 0xe0c00004, 0x18c0001f, 0x10006920, 0x1111041f,
	0xa1108404, 0xe0c00004, 0x810b9801, 0xd8207964, 0x17c07c1f, 0x81019801,
	0xd80078e4, 0x17c07c1f, 0x81489801, 0xd82071a5, 0x17c07c1f, 0x89000009,
	0xfffffff8, 0x1151041f, 0x1290841f, 0xd80072a4, 0x17c07c1f, 0x89000009,
	0x00000006, 0x1150841f, 0x1280041f, 0xd80072a4, 0x17c07c1f, 0x1140041f,
	0x12807c1f, 0xd00072a0, 0x17c07c1f, 0x89000009, 0x00000006, 0x1150841f,
	0x1290841f, 0xd80072a4, 0x17c07c1f, 0x1140041f, 0x1280041f, 0x1a10001f,
	0x100066b4, 0x81101408, 0xd80078e4, 0x17c07c1f, 0xc0c0d0a0, 0x17c07c1f,
	0x81089801, 0xd80075e4, 0x17c07c1f, 0x81009401, 0x81002004, 0x18c0001f,
	0x00000004, 0xc8c0ce44, 0x17c07c1f, 0xc0c0ccc0, 0x17c07c1f, 0x81001401,
	0x8100a004, 0x18c0001f, 0x00000003, 0xc8c0ce44, 0x17c07c1f, 0xd00077a0,
	0x17c07c1f, 0x81011401, 0x8100a004, 0x18c0001f, 0x00000004, 0xc8c0ce44,
	0x17c07c1f, 0xc0c0ccc0, 0x17c07c1f, 0x81009401, 0x81012004, 0x18c0001f,
	0x00000003, 0xc8c0ce44, 0x17c07c1f, 0xc0c0d5e0, 0x17c07c1f, 0x1900001f,
	0x100066b4, 0x18d0001f, 0x100066b4, 0x88c00003, 0x00ffff00, 0xa0d01403,
	0xe1000003, 0xa1d32807, 0x810b9801, 0xd82065a4, 0x17c07c1f, 0xc0c0c9a0,
	0x17c07c1f, 0xa1d28407, 0x81f20407, 0x18d0001f, 0x10006610, 0x80dd8403,
	0xd8007b63, 0x17c07c1f, 0x1950001f, 0x1000661c, 0x80c81401, 0xd8207b63,
	0x81089401, 0xd80043e4, 0x17c07c1f, 0xf0000000, 0x17c07c1f, 0x18c0001f,
	0x1000644c, 0x1940001f, 0x00040707, 0xe0c00005, 0x1b80001f, 0x2000001a,
	0x1940001f, 0x00040007, 0xe0c00005, 0x1b80001f, 0x2000028a, 0x1940001f,
	0x00040000, 0xe0c00005, 0x1b80001f, 0x2000001a, 0x81f98407, 0x81f90407,
	0x1392841f, 0x81f40407, 0x1391841f, 0x1940001f, 0x00000000, 0xe0c00005,
	0x808a9801, 0xcaa0b0e2, 0x1293041f, 0xa19f0406, 0xa1dc0407, 0x1b00001f,
	0x00000090, 0x18c0001f, 0x10006194, 0xe0e00003, 0xf0000000, 0x17c07c1f,
	0xe8208000, 0x10006194, 0x00000001, 0xa1d40407, 0x1391841f, 0xa1d90407,
	0x1392841f, 0x18c0001f, 0x1000644c, 0x1940001f, 0x00040000, 0xe0c00005,
	0x1b80001f, 0x20000020, 0xa1d98407, 0x18c0001f, 0x1000644c, 0x1940001f,
	0x00040007, 0xe0c00005, 0x1940001f, 0x00040707, 0xe0c00005, 0x1940001f,
	0x00040777, 0xe0c00005, 0x808a9801, 0xcaa0b0e2, 0x1293841f, 0x81bf0406,
	0xa1dc0407, 0x1b00001f, 0x00000058, 0x810a9801, 0x81471801, 0x81601404,
	0xd8208545, 0x17c07c1f, 0x1b00001f, 0x00000050, 0xf0000000, 0x17c07c1f,
	0xc0c0a180, 0x17c07c1f, 0xc280b0e0, 0x1294041f, 0xa19f8406, 0xc0c08f40,
	0x17c07c1f, 0xa1d18407, 0xf0000000, 0x17c07c1f, 0x81f18407, 0x80cfb401,
	0xd8008e03, 0x17c07c1f, 0xc0c0a6c0, 0x17c07c1f, 0xd82088e3, 0x17c07c1f,
	0x1a40001f, 0x10006028, 0xe240000f, 0xa1d18407, 0xa1dc0407, 0x13007c1f,
	0x81fc0407, 0xd0008f00, 0x17c07c1f, 0x1a40001f, 0x10006028, 0xe240001f,
	0x80cfb401, 0xd8208b43, 0x17c07c1f, 0xa0180400, 0x17c07c1f, 0x17c07c1f,
	0x81f08407, 0x824ab401, 0xd8008a29, 0x17c07c1f, 0x8244b401, 0xd8008a89,
	0x17c07c1f, 0x80380400, 0xd0008e00, 0x17c07c1f, 0xc0809fc0, 0x17c07c1f,
	0x80cfb401, 0xd8208c63, 0x17c07c1f, 0xc080a180, 0x17c07c1f, 0xd0008e00,
	0x17c07c1f, 0xc280b0e0, 0x1294841f, 0x81bf8406, 0xa1dc0407, 0x1b00001f,
	0x00001120, 0x81461801, 0xd8208dc5, 0x17c07c1f, 0x1b00001f, 0x00001100,
	0xd0008f00, 0x17c07c1f, 0x1950001f, 0x100061e0, 0x1900001f, 0x1000664c,
	0xe1000005, 0xa1d18407, 0xc0c08f40, 0x17c07c1f, 0xf0000000, 0x17c07c1f,
	0x1a40001f, 0x00002100, 0x814a9801, 0x81461805, 0xd8009045, 0x17c07c1f,
	0x1a40001f, 0x00002120, 0x81fc8407, 0xd820918c, 0x17c07c1f, 0xe8208000,
	0x100060b0, 0x00000001, 0x12407c1f, 0x1900001f, 0x10006028, 0xe100000f,
	0x1300241f, 0xf0000000, 0x17c07c1f, 0xe0f07f16, 0x1380201f, 0xe0f07f1e,
	0x1380201f, 0xe0f07f0e, 0xe0f07f0c, 0x1900001f, 0x10006354, 0xe12000fe,
	0xe12000fc, 0xe12000f8, 0xe12000f0, 0xe12000e0, 0xe12000c0, 0xe1200080,
	0xe1200000, 0x1b80001f, 0x20000104, 0xe0f07f0d, 0xe0f07e0d, 0x1b80001f,
	0x2000001a, 0xe0f07c0d, 0x1b80001f, 0x2000001a, 0xe0f0780d, 0x1b80001f,
	0x2000001a, 0xe0f0700d, 0x18c0001f, 0x1000665c, 0x19300003, 0x17c07c1f,
	0x18c0001f, 0x1020e320, 0xe0c00004, 0xf0000000, 0x17c07c1f, 0x1900001f,
	0x10006354, 0xe12000ff, 0xe0f07f0d, 0xe0f07f0f, 0xe0f07f1e, 0xe0f07f12,
	0xf0000000, 0x17c07c1f, 0x80378400, 0xa0150400, 0xa01c0400, 0xa0190400,
	0x81411801, 0xd8009a25, 0x17c07c1f, 0x18c0001f, 0x1000631c, 0xe0e0010d,
	0xe0e0030d, 0xe0e0070d, 0xe0e00f0d, 0x1b80001f, 0x2000001a, 0xe0e00f0f,
	0xe0e00f1f, 0xe0e00f1e, 0xe0e00f12, 0xf0000000, 0x17c07c1f, 0x81411801,
	0xd8009d05, 0x17c07c1f, 0x18c0001f, 0x1000631c, 0xe0e00f16, 0xe0e00f1e,
	0x1950001f, 0x10006184, 0x82411401, 0xd8209b49, 0x17c07c1f, 0xe0e00f0e,
	0x1b80001f, 0x2000001a, 0xe0e00f0c, 0xe0e00f0d, 0xe0e0070d, 0xe0e0030d,
	0xe0e0010d, 0xe0e0000d, 0x80390400, 0x1b80001f, 0x2000001a, 0x803c0400,
	0x1b80001f, 0x20000208, 0x80350400, 0xa0188400, 0x1b80001f, 0x20000002,
	0xa0198400, 0x1b80001f, 0x20000002, 0x80398400, 0x1b80001f, 0x20000005,
	0x80388400, 0xa0178400, 0x1b80001f, 0x20000201, 0xf0000000, 0x17c07c1f,
	0xa1da0407, 0xa1d38407, 0xa0130400, 0xa0138400, 0xa0110400, 0xe8208000,
	0x10006644, 0x00000001, 0x80340400, 0x80360400, 0x80368400, 0x80370400,
	0xf0000000, 0x17c07c1f, 0xa0170400, 0xa0168400, 0xa0180400, 0xa0160400,
	0x1b80001f, 0x2000000a, 0x1b80001f, 0x2000001a, 0xa0140400, 0x1b80001f,
	0x2000000a, 0x1b80001f, 0x2000001a, 0x80330400, 0x80310400, 0x1b80001f,
	0x20000004, 0x1b80001f, 0x2000001a, 0xe8208000, 0x10006648, 0x00000001,
	0xe8208000, 0x100066b8, 0x00000000, 0x80338400, 0x81fa0407, 0x81f38407,
	0x81f08407, 0x824ab401, 0xd800a529, 0x17c07c1f, 0x8244b401, 0xd800a589,
	0x17c07c1f, 0x80380400, 0xa01b8400, 0x1b80001f, 0x20000002, 0x803b8400,
	0xf0000000, 0x17c07c1f, 0x1900001f, 0x00000018, 0xa1d08407, 0xd820a7a4,
	0x80eab401, 0xd800a723, 0x01200404, 0xd820a9a3, 0x17c07c1f, 0xa0180400,
	0x17c07c1f, 0x17c07c1f, 0x81f08407, 0x1900001f, 0x10006780, 0x19700004,
	0x17c07c1f, 0xa1500405, 0xe1000005, 0x824ab401, 0xd800a929, 0x17c07c1f,
	0x80380400, 0xf0000000, 0x17c07c1f, 0xa1d10407, 0x1b80001f, 0x20000020,
	0xf0000000, 0x17c07c1f, 0x1910001f, 0x10006610, 0x81019001, 0xd800ac44,
	0x17c07c1f, 0x1880001f, 0x10006684, 0x18d0001f, 0x10006684, 0x80f00403,
	0xa0d01403, 0xe0800003, 0x1b80001f, 0x2000001a, 0xf0000000, 0x17c07c1f,
	0xe8208000, 0x10006900, 0x00000002, 0xe8208000, 0x1000690c, 0x00000a28,
	0xa1d00407, 0xe8208000, 0x10006900, 0x00000001, 0x808a3401, 0x18d0001f,
	0x10006900, 0x80c78c01, 0xd800b042, 0x17c07c1f, 0xd820adc3, 0x17c07c1f,
	0xa1dc0407, 0x13007c1f, 0x81e00407, 0xe8208000, 0x100060b0, 0x00000001,
	0x1900001f, 0x10006780, 0x19700004, 0x17c07c1f, 0xa1508c05, 0xe1000005,
	0xe8208000, 0x10006900, 0x00000000, 0xf0000000, 0x17c07c1f, 0x18c0001f,
	0x10006604, 0x1910001f, 0x10006604, 0xa1002804, 0xe0c00004, 0xf0000000,
	0x17c07c1f, 0x18d0001f, 0x10006704, 0x80c48c01, 0xd820b1e3, 0x17c07c1f,
	0x1a50001f, 0x10006930, 0x80c7a401, 0x1a40001f, 0x10006780, 0x19700009,
	0x17c07c1f, 0xa1510c05, 0xe2400005, 0xf0000000, 0x17c07c1f, 0x1900001f,
	0x1000647c, 0xe100001f, 0xf0000000, 0x17c07c1f, 0xa0158400, 0x18d0001f,
	0x1022c204, 0xa8c00003, 0x00008000, 0x1940001f, 0x1022c204, 0xe1400003,
	0x1940001f, 0x10232204, 0xe1400003, 0xf0000000, 0x17c07c1f, 0x80358400,
	0x18d0001f, 0x1022c204, 0x88c00003, 0xffff7fff, 0x1940001f, 0x1022c204,
	0xe1400003, 0x1940001f, 0x10232204, 0xe1400003, 0xf0000000, 0x17c07c1f,
	0xf0000000, 0x17c07c1f, 0xf0000000, 0x17c07c1f, 0x1910001f, 0x1022c064,
	0xa9000004, 0x00000020, 0x1940001f, 0x1022c064, 0xe1400004, 0x1910001f,
	0x1022c05c, 0x88c00004, 0xf3e000ff, 0xa9000003, 0x00000400, 0x1940001f,
	0x1022c05c, 0xe1400004, 0x1910001f, 0x1022c060, 0xa9000004, 0x00000002,
	0x1940001f, 0x1022c060, 0xe1400004, 0x10c07c1f, 0x1910001f, 0x1022e088,
	0x88c00004, 0x00000002, 0xd820bb43, 0x17c07c1f, 0x1910001f, 0x1022c060,
	0x89000004, 0xfffffffd, 0x1940001f, 0x1022c060, 0xe1400004, 0x1910001f,
	0x1022c064, 0x89000004, 0xffffffdf, 0x1940001f, 0x1022c064, 0xe1400004,
	0x1910001f, 0x10232064, 0xa9000004, 0x00000020, 0x1940001f, 0x10232064,
	0xe1400004, 0x1910001f, 0x1023205c, 0x88c00004, 0xf3e000ff, 0xa9000003,
	0x00000400, 0x1940001f, 0x1023205c, 0xe1400004, 0x1910001f, 0x10232060,
	0xa9000004, 0x00000002, 0x1940001f, 0x10232060, 0xe1400004, 0x10c07c1f,
	0x1910001f, 0x10238088, 0x88c00004, 0x00000002, 0xd820c0c3, 0x17c07c1f,
	0x1910001f, 0x10238060, 0x89000004, 0xfffffffd, 0x1940001f, 0x10238060,
	0xe1400004, 0x1910001f, 0x10238064, 0x89000004, 0xffffffdf, 0x1940001f,
	0x10238064, 0xe1400004, 0xf0000000, 0x17c07c1f, 0x1a40001f, 0x1022f3fc,
	0x19300009, 0x17c07c1f, 0xa1100404, 0xe2400004, 0x19300009, 0x17c07c1f,
	0x1a40001f, 0x102393fc, 0x19300009, 0x17c07c1f, 0xa1100404, 0xe2400004,
	0x19300009, 0x17c07c1f, 0xf0000000, 0x17c07c1f, 0x1a40001f, 0x1022f3fc,
	0x19300009, 0x17c07c1f, 0x81300404, 0xe2400004, 0x19300009, 0x17c07c1f,
	0x1a40001f, 0x102393fc, 0x19300009, 0x17c07c1f, 0x81300404, 0xe2400004,
	0x19300009, 0x17c07c1f, 0xf0000000, 0x17c07c1f, 0x18c0001f, 0x1000647c,
	0x1880001f, 0x00000003, 0xe0c00002, 0x18d0001f, 0x1000647c, 0xa1540802,
	0x71301403, 0xd800c8a4, 0x17c07c1f, 0xf0000000, 0x17c07c1f, 0x1900001f,
	0x100066a4, 0xe1000009, 0x81f30407, 0x81bb8406, 0x18c0001f, 0x10006658,
	0x1890001f, 0x10006658, 0x809f8402, 0xa0802402, 0xe0c00002, 0x18c0001f,
	0x10006780, 0xe0c00002, 0xe100001f, 0xa1dc0407, 0x1890001f, 0x10006148,
	0x18c0001f, 0x00000100, 0xa0c00803, 0x13000c1f, 0xf0000000, 0x17c07c1f,
	0x1900001f, 0x10006700, 0xe100000a, 0x1910001f, 0x10006704, 0x81049001,
	0xd820cd24, 0x17c07c1f, 0x1b80001f, 0x200003fc, 0xf0000000, 0x17c07c1f,
	0x1910001f, 0x10006610, 0x810c9001, 0xd800d024, 0x17c07c1f, 0x1900001f,
	0x10006700, 0xe1000003, 0x1910001f, 0x10006704, 0x81049001, 0xd820cf44,
	0x17c07c1f, 0x1b80001f, 0x200003fc, 0xf0000000, 0x17c07c1f, 0xf0000000,
	0x17c07c1f, 0xa0180400, 0x1b80001f, 0x20000004, 0x18c0001f, 0x10006478,
	0x1910001f, 0x10006478, 0x89000004, 0xfffffefe, 0xe0c00004, 0x1b80001f,
	0x20000004, 0x18c0001f, 0x10006478, 0x1910001f, 0x10006478, 0xa9000004,
	0x00000404, 0xe0c00004, 0x1b80001f, 0x20000004, 0x18c0001f, 0x10006478,
	0x1910001f, 0x10006478, 0xa9000004, 0x00000202, 0xe0c00004, 0x1b80001f,
	0x20000004, 0x18c0001f, 0x10006478, 0x1910001f, 0x10006478, 0xa9000004,
	0x00000101, 0xe0c00004, 0x1b80001f, 0x20000004, 0x80380400, 0xf0000000,
	0x17c07c1f, 0xa0180400, 0x1b80001f, 0x20000004, 0x18c0001f, 0x10006478,
	0x1910001f, 0x10006478, 0x89000004, 0xfffffefe, 0xe0c00004, 0x1b80001f,
	0x20000004, 0x18c0001f, 0x10006478, 0x1910001f, 0x10006478, 0xa9000004,
	0x00000404, 0xe0c00004, 0x1b80001f, 0x20000004, 0x80cf8001, 0x810f0001,
	0xa0c01003, 0xd800db63, 0x17c07c1f, 0x18c0001f, 0x10006478, 0x1910001f,
	0x10006478, 0x89000004, 0xfffffdfd, 0xe0c00004, 0x1b80001f, 0x20000004,
	0x18c0001f, 0x10006478, 0x1910001f, 0x10006478, 0xa9000004, 0x00000101,
	0xe0c00004, 0x1b80001f, 0x20000004, 0x80380400, 0xf0000000, 0x17c07c1f,
	0x18c0001f, 0x1022c064, 0x1910001f, 0x1022c064, 0x813e8404, 0xe0c00004,
	0x18c0001f, 0x10232064, 0x1910001f, 0x10232064, 0x813e8404, 0xe0c00004,
	0x18c0001f, 0x1000645c, 0xe0c0001f, 0xf0000000, 0x17c07c1f, 0x18c0001f,
	0x1000645c, 0x1900001f, 0x0000001f, 0xe0c00004, 0x803d0400, 0x803d8400,
	0x8111040a, 0x803f0400, 0x803f8400, 0xd800e044, 0x17c07c1f, 0x8110840a,
	0xa01f0400, 0x803f8400, 0xd800e044, 0x17c07c1f, 0x803f0400, 0xa01f8400,
	0xf0000000, 0x17c07c1f, 0x820c1801, 0x91bc0406, 0xd800e5a8, 0x17c07c1f,
	0x18c0001f, 0x10006604, 0x1910001f, 0x10006604, 0xa11c0404, 0xe0c00004,
	0xa01d0400, 0x1b80001f, 0x20000022, 0x8111040a, 0xd820e444, 0x17c07c1f,
	0x18d0001f, 0x100065ec, 0x81008c01, 0xd820e444, 0x17c07c1f, 0x18c0001f,
	0x10228d94, 0x1900001f, 0x76000002, 0xe0c00004, 0x1910001f, 0x10228d94,
	0xd000e520, 0x17c07c1f, 0x18c0001f, 0x10228d94, 0x1900001f, 0x7b000002,
	0xe0c00004, 0x1910001f, 0x10228d94, 0xa0158400, 0xa01e0400, 0xd000ea00,
	0x17c07c1f, 0x18c0001f, 0x10006604, 0x1910001f, 0x10006604, 0xa11c8404,
	0xe0c00004, 0xa01d8400, 0x1b80001f, 0x20000022, 0x8111040a, 0xd820e8e4,
	0x17c07c1f, 0x18d0001f, 0x100065ec, 0x81008c01, 0xd820e8e4, 0x17c07c1f,
	0x18c0001f, 0x10228d9c, 0x1900001f, 0x76000002, 0xe0c00004, 0x1910001f,
	0x10228d9c, 0xd000e9c0, 0x17c07c1f, 0x18c0001f, 0x10228d9c, 0x1900001f,
	0x7b000002, 0xe0c00004, 0x1910001f, 0x10228d9c, 0xa0158400, 0xa01e8400,
	0x18c0001f, 0x10006900, 0x1111041f, 0xa1108404, 0xe0c00004, 0x18c0001f,
	0x1000690c, 0xe0e00550, 0x18c0001f, 0x10006900, 0xe0c00001, 0x18c0001f,
	0x1022c064, 0x1910001f, 0x1022c064, 0xa11e8404, 0xe0c00004, 0x18c0001f,
	0x10232064, 0x1910001f, 0x10232064, 0xa11e8404, 0xe0c00004, 0x18d0001f,
	0x10006900, 0x81078c01, 0xd820ece4, 0x17c07c1f, 0x18c0001f, 0x10006900,
	0x1111041f, 0xa1108404, 0xe0c00004, 0x1890001f, 0x10006658, 0x18c0001f,
	0x10006658, 0x90bf8402, 0xe0c00002, 0xa0180400, 0x1b80001f, 0x20000004,
	0x803c8400, 0x1900001f, 0x10006680, 0x18d0001f, 0x10017008, 0xe1000003,
	0x17c07c1f, 0xa01b0400, 0x80cbb401, 0xd820f043, 0x17c07c1f, 0x803b0400,
	0x80cf8001, 0x810f0001, 0xa0c01003, 0xd800f183, 0x17c07c1f, 0xa01c8400,
	0x80380400, 0xd800f308, 0x17c07c1f, 0x803e8400, 0x18c0001f, 0x10006604,
	0x1910001f, 0x10006604, 0x813c0404, 0xe0c00004, 0xd000f3e0, 0x17c07c1f,
	0x803e0400, 0x18c0001f, 0x10006604, 0x1910001f, 0x10006604, 0x813c8404,
	0xe0c00004, 0xf0000000, 0x17c07c1f, 0x18d0001f, 0x1022ce64, 0x1900001f,
	0x1022ce64, 0x88c00003, 0xf00fffff, 0xe1000003, 0x1950001f, 0x1022e468,
	0x1890001f, 0x1022e468, 0x18d0001f, 0x1022e468, 0x61300c02, 0xd820f6c4,
	0x17c07c1f, 0x1900001f, 0x10228200, 0xe1000003, 0xd000f720, 0x17c07c1f,
	0x1900001f, 0x10228200, 0xe1200000, 0x1950001f, 0x1022e460, 0x1890001f,
	0x1022e460, 0x18d0001f, 0x1022e460, 0x61300c02, 0xd820f924, 0x17c07c1f,
	0xd820f922, 0x17c07c1f, 0x1900001f, 0x10228204, 0xe1000003, 0xd000f9c0,
	0x17c07c1f, 0xd820f9c5, 0x17c07c1f, 0x1900001f, 0x10228204, 0xe1200000,
	0x18d0001f, 0x1022ce64, 0x1900001f, 0x1022ce64, 0xa8c00003, 0x00100000,
	0xe1000003, 0xf0000000, 0x17c07c1f, 0x1950001f, 0x10228200, 0x1890001f,
	0x10228200, 0x18d0001f, 0x10228200, 0x61300c02, 0x70b07c03, 0x81000804,
	0xd820fd04, 0x17c07c1f, 0x1900001f, 0x10232eb8, 0xe1000003, 0x1900001f,
	0x1022ceb8, 0xe1000003, 0x1950001f, 0x10228204, 0x1890001f, 0x10228204,
	0x18d0001f, 0x10228204, 0x61300c02, 0xd820ff64, 0x17c07c1f, 0xd820ff62,
	0x17c07c1f, 0x1900001f, 0x10232ebc, 0xe1000003, 0x1900001f, 0x1022cebc,
	0xe1000003, 0xd000ffa0, 0x17c07c1f, 0xd820ffa5, 0x17c07c1f, 0xf0000000,
	0x17c07c1f, 0x17c07c1f, 0x1840001f, 0x00000001, 0x19c0001f, 0x00015828,
	0x1990001f, 0x10006600, 0xa9800006, 0xf8000000, 0x18d0001f, 0x10006658,
	0x80cf8c01, 0xa19c0c06, 0xe8208000, 0x100060b0, 0x00000000, 0xe8208000,
	0x100065f0, 0x00000000, 0xe8208000, 0x10006604, 0x00000000, 0xe8208000,
	0x10006780, 0x00000000, 0xe8208000, 0x10006608, 0x00000000, 0x18c0001f,
	0x1000661c, 0x1910001f, 0x1000661c, 0x89000004, 0x8000ffff, 0xe0c00004,
	0x18c0001f, 0x10006460, 0x1900001f, 0x00ffffff, 0xe0c00004, 0x18c0001f,
	0x10006470, 0x1900001f, 0x0003ff7f, 0xe0c00004, 0x81550406, 0xd8016e85,
	0x17c07c1f, 0xa1d48407, 0x815a8406, 0xd8210705, 0x17c07c1f, 0xa1908406,
	0x81570406, 0xd8010705, 0x17c07c1f, 0xa1dd8407, 0x81fc0407, 0x1b00001f,
	0xbfffffff, 0xa1dc0407, 0x1b00001f, 0x00000100, 0xe8208000, 0x10006080,
	0x00000100, 0x81439801, 0xd8010f05, 0x17c07c1f, 0x1b80001f, 0xd00f0000,
	0x81fc8407, 0x81fc0407, 0x1b00001f, 0xbfffffff, 0x8a40000c, 0xbfffffff,
	0x81479801, 0xd8210a65, 0x17c07c1f, 0xc280b0e0, 0x1297041f, 0xd0010ba0,
	0x17c07c1f, 0xd8210f89, 0x17c07c1f, 0xc280b0e0, 0x1297841f, 0x18c0001f,
	0x10006608, 0xe0c0000c, 0x81401801, 0xd80167e5, 0x17c07c1f, 0x18c0001f,
	0x0000000f, 0x1a50001f, 0x10006174, 0x82452403, 0x62700c09, 0xd8210ba9,
	0x17c07c1f, 0x18d0001f, 0x10006574, 0x19300003, 0x17c07c1f, 0x17c07c1f,
	0x81300404, 0xe0c00004, 0x81479801, 0xd8210e85, 0x17c07c1f, 0xd8210dec,
	0x17c07c1f, 0x1940001f, 0x10006608, 0xe140000c, 0xa1100404, 0xe0c00004,
	0xd00167e0, 0x17c07c1f, 0x81fc0407, 0x13007c1f, 0x1b80001f, 0xd000aaaa,
	0x81fc0407, 0x13007c1f, 0x18c0001f, 0x0000000f, 0x1a50001f, 0x10006174,
	0x82452403, 0x62700c09, 0xd8210fc9, 0x17c07c1f, 0xe8208000, 0x10006408,
	0x00000100, 0xe8208000, 0x1000640c, 0x00000000, 0xc0c0a9e0, 0x17c07c1f,
	0x18d0001f, 0x10006168, 0x88c00003, 0x00000100, 0x69200003, 0x00000100,
	0xd82111c4, 0x17c07c1f, 0x17c07c1f, 0xc0c0b480, 0x17c07c1f, 0x81401801,
	0xd8012aa5, 0x17c07c1f, 0x80c41801, 0xd8011403, 0x17c07c1f, 0x81f60407,
	0x18d0001f, 0x10006574, 0x19300003, 0x17c07c1f, 0x81318404, 0xe0c00004,
	0x81310404, 0xe0c00004, 0x19300003, 0x17c07c1f, 0x810f1001, 0x19700003,
	0x17c07c1f, 0x814f9401, 0xa1001404, 0xd8011504, 0x17c07c1f, 0x19300003,
	0x17c07c1f, 0x81300404, 0xe0c00004, 0xc280b0e0, 0x1298041f, 0x18d0001f,
	0x10006650, 0x80cf8c01, 0xd8012aa3, 0x17c07c1f, 0x1a50001f, 0x10006174,
	0x824a2401, 0xd8211789, 0x17c07c1f, 0xe8208000, 0x1000640c, 0x04003400,
	0x18d0001f, 0x1000616c, 0x88c00003, 0x04003400, 0x69200003, 0x04003400,
	0xd8211884, 0x17c07c1f, 0x18d0001f, 0x10006570, 0x19300003, 0x17c07c1f,
	0x81318404, 0xe0c00004, 0x81310404, 0xe0c00004, 0x19300003, 0x17c07c1f,
	0x810f1001, 0x19700003, 0x17c07c1f, 0x814f9401, 0xa1001404, 0xd8011a84,
	0x17c07c1f, 0xc280b0e0, 0x1299041f, 0x18c0001f, 0x00000003, 0x1a50001f,
	0x10006174, 0x824b2403, 0x62700c09, 0xd8211be9, 0x17c07c1f, 0xe8208000,
	0x10006408, 0x00000301, 0x18d0001f, 0x10006168, 0x88c00003, 0x00000301,
	0x69200003, 0x00000301, 0xd8211d44, 0x17c07c1f, 0xe8208000, 0x1000640c,
	0x06003600, 0x18d0001f, 0x1000616c, 0x88c00003, 0x06003600, 0x69200003,
	0x06003600, 0xd8211ea4, 0x17c07c1f, 0x814a9801, 0xd80121c5, 0x17c07c1f,
	0x18c0001f, 0x10219400, 0x1910001f, 0x10219400, 0xa1118404, 0xe0c00004,
	0x1b80001f, 0xa0000104, 0x18c0001f, 0x10219400, 0x1910001f, 0x10219400,
	0x81318404, 0xe0c00004, 0x1ac0001f, 0x10006200, 0x1880001f, 0x0000104d,
	0x1900001f, 0x102007c0, 0x1950001f, 0x102007c0, 0x8a400005, 0xfffff9ff,
	0xe1000009, 0x1b80001f, 0x2000001a, 0xa0908402, 0xe2c00002, 0xa0928402,
	0xe2c00002, 0x1950001f, 0x10006610, 0x81409401, 0xd80125e5, 0x17c07c1f,
	0xa0940402, 0xe2c00002, 0x1b80001f, 0xa0000001, 0x1950001f, 0x10006200,
	0x810c1401, 0xd82124c4, 0x17c07c1f, 0xd0012720, 0x17c07c1f, 0x1ac0001f,
	0x10006200, 0x18b0000b, 0x17c07c1f, 0x80b30402, 0xe2c00002, 0x1b80001f,
	0x20000003, 0x80b60402, 0xe2c00002, 0x1ac0001f, 0x10006200, 0x18b0000b,
	0x17c07c1f, 0xa0938402, 0xe2c00002, 0x80b00402, 0xe2c00002, 0xa0920402,
	0xe2c00002, 0x80b10402, 0xe2c00002, 0x80b18402, 0xe2c00002, 0x1930000b,
	0x17c07c1f, 0x810f1001, 0x1970000b, 0x17c07c1f, 0x814f9401, 0xa1001404,
	0xd80128e4, 0x17c07c1f, 0xe8208000, 0x10006290, 0x00000007, 0xc280b0e0,
	0x129a041f, 0xa1dc0407, 0x1b00001f, 0x00000100, 0xa1dc0407, 0x1b00001f,
	0x00000100, 0x1b80001f, 0xa0000001, 0x81481801, 0xd8012ee5, 0x17c07c1f,
	0x1a40001f, 0x10006350, 0x1910001f, 0x10006350, 0x1900001f, 0xffffff00,
	0xe2400004, 0x1900001f, 0x00ffff00, 0xe2400004, 0x1900001f, 0x0000ff00,
	0xe2400004, 0x1a40001f, 0x100063d4, 0x1910001f, 0x100063d4, 0xa1100404,
	0xe2400004, 0x81308404, 0xe2400004, 0x81320404, 0xe2400004, 0x81449801,
	0xd80134c5, 0x17c07c1f, 0x1910001f, 0x10006610, 0x81011001, 0x1890001f,
	0x10006600, 0x80c98801, 0xd8213123, 0x17c07c1f, 0x1a00001f, 0x10006700,
	0xd8013124, 0x17c07c1f, 0xe220000c, 0xd0013180, 0x17c07c1f, 0x1a00001f,
	0x10006700, 0xe2200008, 0xc0c0b1e0, 0x17c07c1f, 0x1b80001f, 0xa0000001,
	0x1890001f, 0x10006600, 0x80c98801, 0xd82133e3, 0x17c07c1f, 0x1a00001f,
	0x10006700, 0x1910001f, 0x10006610, 0x81011001, 0xd80133e4, 0x17c07c1f,
	0xe220000e, 0xd0013440, 0x17c07c1f, 0x1a00001f, 0x10006700, 0xe220000a,
	0xc0c0b1e0, 0x17c07c1f, 0x1b80001f, 0xa0000001, 0xc0c17c80, 0x17c07c1f,
	0x1b80001f, 0xa0000001, 0x1b80001f, 0xa0000001, 0x81fc0407, 0x1b00001f,
	0xbfffffff, 0x1a40001f, 0x00002d7f, 0x81fc0407, 0x1b00001f, 0xbfffffff,
	0x18c0001f, 0x00002120, 0x814a9801, 0xd8213a45, 0x17c07c1f, 0x1a40001f,
	0x00000000, 0x18c0001f, 0x00000000, 0x81469801, 0xd8013a45, 0x17c07c1f,
	0x1a40001f, 0x00002140, 0x18c0001f, 0x00002100, 0x81461801, 0xd8013a45,
	0x17c07c1f, 0x1a40001f, 0x00002d70, 0x18c0001f, 0x00002120, 0x81471801,
	0xd8213a45, 0x17c07c1f, 0x1a40001f, 0x00002d7f, 0x18c0001f, 0x00002120,
	0x1900001f, 0x10006080, 0x814d1801, 0xd8213b65, 0x17c07c1f, 0x8a400009,
	0xfffffffc, 0xaa400009, 0x00000280, 0xe1000009, 0xa1dc0407, 0x13000c1f,
	0xe8208000, 0x1000660c, 0x00000008, 0xe8208000, 0x1000660c, 0x0000000a,
	0xa1dc0407, 0x1b80001f, 0x90100000, 0x80cd9801, 0x810d1801, 0xa0c01003,
	0xc8e004c3, 0x17c07c1f, 0x80cd9801, 0x810d1801, 0x81201001, 0xa0c01003,
	0xc8e00003, 0x17c07c1f, 0x80ce1801, 0xc8e02143, 0x17c07c1f, 0x80cf1801,
	0xc8e07ba3, 0x17c07c1f, 0x80cf9801, 0xc8e08583, 0x17c07c1f, 0x80ce9801,
	0xc8e03083, 0x17c07c1f, 0x18d0001f, 0x10006160, 0x80c40c01, 0xc8c051a3,
	0x17c07c1f, 0x81fc8407, 0x18c0001f, 0x10006608, 0xe0c0000c, 0xe8208000,
	0x100060c4, 0xffffffff, 0xa1dc0407, 0x1b00001f, 0x00000100, 0x81fc0407,
	0x13007c1f, 0xe8208000, 0x10006080, 0x00000100, 0x1b80001f, 0xa0000001,
	0x81481801, 0xd80148e5, 0x17c07c1f, 0x1a40001f, 0x10006350, 0x1910001f,
	0x10006350, 0x1900001f, 0x0001ff00, 0xe2400004, 0x1900001f, 0x0003ff00,
	0xe2400004, 0x1900001f, 0x0007ff00, 0xe2400004, 0x1900001f, 0x000fff00,
	0xe2400004, 0x1900001f, 0x001fff00, 0xe2400004, 0x1900001f, 0x003fff00,
	0xe2400004, 0x1900001f, 0x007fff00, 0xe2400004, 0x1900001f, 0x00ffff00,
	0xe2400004, 0x1b80001f, 0x20000020, 0x1900001f, 0xffffff00, 0xe2400004,
	0x1900001f, 0xffff0000, 0xe2400004, 0x1a40001f, 0x100063d4, 0x1910001f,
	0x100063d4, 0xa1120404, 0xe2400004, 0x1b80001f, 0x20000020, 0xa1108404,
	0xe2400004, 0x81300404, 0xe2400004, 0x1b80001f, 0xa0000001, 0x18c0001f,
	0x100062bc, 0xe0e039ff, 0x1b80001f, 0xa0000300, 0x18c0001f, 0x100062bc,
	0xe0e001ff, 0x1b80001f, 0xa0000300, 0x18c0001f, 0x100062bc, 0xe0e0003f,
	0x1b80001f, 0xa0000104, 0x18c0001f, 0x100062bc, 0xe0e00007, 0xe0e00000,
	0x814a9801, 0xd8014be5, 0x17c07c1f, 0x1b80001f, 0xa0000001, 0x81449801,
	0xd8015405, 0x17c07c1f, 0x1910001f, 0x10006610, 0x81011001, 0x1890001f,
	0x10006600, 0x80c98801, 0xd8214e63, 0x17c07c1f, 0x1a00001f, 0x10006700,
	0xd8014e64, 0x17c07c1f, 0xe220000f, 0xd0014ec0, 0x17c07c1f, 0x1a00001f,
	0x10006700, 0xe220000b, 0xc0c0b1e0, 0x17c07c1f, 0x1b80001f, 0xa0000001,
	0x1890001f, 0x10006600, 0x80c98801, 0xd8215263, 0x17c07c1f, 0x1a00001f,
	0x10006700, 0x1910001f, 0x10006610, 0x81011001, 0xd8015264, 0x17c07c1f,
	0xe220000d, 0xc0c0b1e0, 0x17c07c1f, 0x1b80001f, 0xa0001615, 0xe8208000,
	0x1000660c, 0x0000000f, 0xe8208000, 0x1000660c, 0x0000000d, 0xd0015400,
	0x17c07c1f, 0x1a00001f, 0x10006700, 0xe2200009, 0xc0c0b1e0, 0x17c07c1f,
	0x1b80001f, 0xa0001615, 0xe8208000, 0x1000660c, 0x0000000b, 0xe8208000,
	0x1000660c, 0x00000009, 0x18d0001f, 0x10006164, 0x80c98c01, 0x1900001f,
	0x1000641c, 0x1950001f, 0x1000641c, 0xa1598c05, 0xe1000005, 0x18c0001f,
	0x1000601c, 0x1910001f, 0x1000601c, 0xa9000004, 0x0b160000, 0x81328404,
	0xe0c00004, 0x81401801, 0xd80167a5, 0x17c07c1f, 0x18d0001f, 0x10006650,
	0x80cf8c01, 0xd80165c3, 0x17c07c1f, 0xe8208000, 0x10006290, 0x00000000,
	0x1ac0001f, 0x10006200, 0x1890001f, 0x10006200, 0xa0910402, 0xe2c00002,
	0xa0918402, 0xe2c00002, 0x1b80001f, 0x2000001a, 0x1950001f, 0x10006180,
	0x1b80001f, 0xa0000001, 0x1950001f, 0x10006180, 0x81071401, 0x1950001f,
	0x10006184, 0x81471401, 0x81001404, 0xd82158c4, 0x17c07c1f, 0x1ac0001f,
	0x10006200, 0x1890001f, 0x10006200, 0x80b08402, 0xe2c00002, 0x1950001f,
	0x10006610, 0x81409401, 0xd8015d65, 0x17c07c1f, 0x80b38402, 0xe2c00002,
	0x80b40402, 0xe2c00002, 0x1b80001f, 0xa0000001, 0x1950001f, 0x10006200,
	0x810c1401, 0xd8015c44, 0x17c07c1f, 0xd0015f80, 0x17c07c1f, 0x1ac0001f,
	0x10006200, 0x18b0000b, 0x17c07c1f, 0xa0960402, 0xe2c00002, 0x80b38402,
	0xe2c00002, 0x17c07c1f, 0x1b80001f, 0x2000001a, 0x1ac0001f, 0x10006200,
	0x18b0000b, 0x17c07c1f, 0xa0930402, 0xe2c00002, 0x1ac0001f, 0x10006200,
	0x18b0000b, 0x17c07c1f, 0x80b28402, 0xe2c00002, 0x1b80001f, 0x2000001a,
	0x80b20402, 0xe2c00002, 0xa0900402, 0xe2c00002, 0x1900001f, 0x102007c0,
	0x1950001f, 0x102007c0, 0xa8800005, 0x00000200, 0xe1000002, 0xe8208000,
	0x10006408, 0x00000100, 0xe8208000, 0x1000640c, 0x04003400, 0x1b80001f,
	0xa0000104, 0xc280b0e0, 0x129a841f, 0x18d0001f, 0x10006570, 0x19300003,
	0x17c07c1f, 0xa1110404, 0xe0c00004, 0x19300003, 0x17c07c1f, 0x810f1001,
	0xd82163e4, 0x17c07c1f, 0xe8208000, 0x10006408, 0x00000100, 0xe8208000,
	0x1000640c, 0x00000000, 0x1b80001f, 0xa0000104, 0xc280b0e0, 0x1299841f,
	0x18d0001f, 0x10006574, 0x19300003, 0x17c07c1f, 0xa1100404, 0xe0c00004,
	0xa1110404, 0xe0c00004, 0x19300003, 0x17c07c1f, 0x810f1001, 0xd82166c4,
	0x17c07c1f, 0xc280b0e0, 0x1298841f, 0xc0c0b620, 0x17c07c1f, 0x814a9801,
	0xb14a18a1, 0xd80168c5, 0x17c07c1f, 0xe8208000, 0x10006034, 0x000f0000,
	0x81570406, 0xd8016945, 0x17c07c1f, 0x81fd8407, 0x81f48407, 0xa1d60407,
	0x81f10407, 0x18c0001f, 0x1000641c, 0x1910001f, 0x10006164, 0x1950001f,
	0x1000641c, 0x81499401, 0xa1199404, 0xe0c00004, 0x18c0001f, 0x10006420,
	0x1910001f, 0x10006150, 0xe0c00004, 0x18c0001f, 0x10006424, 0x1910001f,
	0x1000614c, 0xe0c00004, 0x1b80001f, 0xa0000001, 0x18c0001f, 0x10006614,
	0x1910001f, 0x10006614, 0x09000004, 0x00000001, 0xe0c00004, 0xa1dc0407,
	0x1b00001f, 0x00000000, 0x1ac0001f, 0x55aa55aa, 0xe8208000, 0x10006090,
	0x00000001, 0x81429801, 0xd8017b45, 0x17c07c1f, 0x18c0001f, 0x10006604,
	0x1910001f, 0x10006604, 0xa1150404, 0xe0c00004, 0xe8208000, 0x10006080,
	0x00000100, 0x81fc0407, 0x1b00001f, 0x00000001, 0xa1dc0407, 0x1b00001f,
	0x00000100, 0x1b80001f, 0x90100000, 0x1890001f, 0x100060b0, 0xd80172c2,
	0x17c07c1f, 0x1890001f, 0x10006164, 0x1900001f, 0x00000007, 0x80c90804,
	0x1880001f, 0x1000661c, 0x1910001f, 0x1000661c, 0xa11e0c04, 0xe0800004,
	0xd0016fa0, 0x17c07c1f, 0x18d0001f, 0x100065f0, 0xd8216fa3, 0x17c07c1f,
	0x18c0001f, 0x10006604, 0x1910001f, 0x10006604, 0x813e8404, 0xe0c00004,
	0x18d0001f, 0x100065ec, 0x81000c01, 0xd82179c4, 0x17c07c1f, 0x81f20407,
	0x81f28407, 0x1291041f, 0x810f0001, 0x18c0001f, 0x10006654, 0xe0c00004,
	0xd8217604, 0x17c07c1f, 0xc0c0f420, 0x17c07c1f, 0xc0c0dde0, 0x17c07c1f,
	0xc0c0e080, 0x17c07c1f, 0xc0c0d0a0, 0x17c07c1f, 0x1b80001f, 0x20000110,
	0xc0c0d5e0, 0x17c07c1f, 0x1910001f, 0x10006654, 0xd8217804, 0x17c07c1f,
	0xc0c0fae0, 0x17c07c1f, 0xc0c0dbc0, 0x17c07c1f, 0x18c0001f, 0x100065d0,
	0xe0c00001, 0x18d0001f, 0x100065d0, 0x81000c01, 0xd80178a4, 0x17c07c1f,
	0xa1d28407, 0x81f20407, 0xd0016e80, 0x17c07c1f, 0x1ac0001f, 0x77887788,
	0x1950001f, 0x10006610, 0x81439401, 0xd8017b45, 0x17c07c1f, 0xa0148400,
	0x81fc0407, 0x80348400, 0xd0010040, 0x17c07c1f, 0xf0000000, 0x17c07c1f,
	0x18c0001f, 0x10006604, 0x1910001f, 0x10006604, 0x81350404, 0xe0c00004,
	0xf0000000, 0x17c07c1f, 0x814a9801, 0xd8017ce5, 0x17c07c1f, 0x18c0001f,
	0x100062bc, 0xe0e00007, 0xe0e0003f, 0xe0e001ff, 0xe0e031ff, 0xe0e039ff,
	0xe0e03fff, 0xe0e07fff, 0xf0000000, 0x17c07c1f
};

static struct pcm_desc suspend_pcm = {
	.version	= "20200716 8168_spm_fw",
	.base		= suspend_binary,
	.size		= 3058,
	.sess		= 2,
	.replace	= 0,
	.addr_2nd	= 0,
	.vec0		= EVENT_VEC(32, 1, 0, 38),	/* FUNC_26M_WAKEUP */
	.vec1		= EVENT_VEC(33, 1, 0, 134),	/* FUNC_26M_SLEEP */
	.vec2		= EVENT_VEC(34, 1, 0, 266),	/* FUNC_INFRA_WAKEUP */
	.vec3		= EVENT_VEC(35, 1, 0, 313),	/* FUNC_INFRA_SLEEP */
	.vec4		= EVENT_VEC(36, 1, 0, 388),	/* FUNC_APSRC_WAKEUP */
	.vec5		= EVENT_VEC(37, 1, 0, 520),	/* FUNC_APSRC_SLEEP */
	.vec6		= EVENT_VEC(44, 1, 0, 1068),	/* FUNC_DDREN_WAKEUP */
	.vec7		= EVENT_VEC(32, 1, 0, 0),	/* FUNC_FAKE26M_WAKEUP */
	.vec8		= EVENT_VEC(40, 1, 0, 653),	/* FUNC_DVFS_STATE_ALL */
	.vec9		= EVENT_VEC(33, 1, 0, 17),	/* FUNC_FAKE26M_SLEEP */
	.vec10		= EVENT_VEC(38, 1, 0, 989),	/* FUNC_VRF18_WAKEUP */
	.vec11		= EVENT_VEC(39, 1, 0, 1026),	/* FUNC_VRF18_SLEEP */
	.vec13		= EVENT_VEC(45, 1, 0, 1078),	/* FUNC_DDREN_SLEEP */
};

static void spm_add_dram_type_control(struct pwr_ctrl *pwrctrl, bool print_log)
{
	uint32_t dram_type;

	dram_type = (mmio_read_32(DRAMC_REG_ARBCTL) & 0x3c00) >> 10;
	__spmfw_idx = dram_type;

	switch (dram_type) {
	case TYPE_PCDDR3:
		if (print_log == 1)
			INFO("0x1022c010 = 0x%x, PCDDR3\n", dram_type);
		pwrctrl->pcm_flags |= SPM_FLAG_DISABLE_IMP_TRACKING;
		break;
	case TYPE_PCDDR4:
		if (print_log == 1)
			INFO("0x1022c010 = 0x%x, PCDDR4\n", dram_type);
		pwrctrl->pcm_flags |= SPM_FLAG_DISABLE_IMP_TRACKING;
		break;
	case TYPE_LPDDR3:
		if (print_log == 1)
			INFO("0x1022c010 = 0x%x, LPDDR3\n", dram_type);
		pwrctrl->pcm_flags |= SPM_FLAG_DRAM_LPDDR_TYPE;
		pwrctrl->pcm_flags |= SPM_FLAG_DISABLE_IMP_TRACKING;
		break;
	case TYPE_LPDDR4:
		if (print_log == 1)
			INFO("0x1022c010 = 0x%x, LPDDR4\n", dram_type);
		pwrctrl->pcm_flags |= SPM_FLAG_DRAM_LPDDR_TYPE;
		break;
	case TYPE_LPDDR4X:
		if (print_log == 1)
			INFO("0x1022c010 = 0x%x, LPDDR4X\n", dram_type);
		pwrctrl->pcm_flags |= SPM_FLAG_DRAM_LPDDR_TYPE;
		break;
	case TYPE_LPDDR4P:
		if (print_log == 1)
			INFO("0x1022c010 = 0x%x, LPDDR4P\n", dram_type);
		pwrctrl->pcm_flags |= SPM_FLAG_DRAM_LPDDR_TYPE;
		break;
	default:
		if (print_log == 1)
			INFO("0x1022c010 = 0x%x, unknown dram type\n",
			     dram_type);
	}
}

const char *spm_get_firmware_version(void)
{
	return suspend_pcm.version;
}

void spm_lock_init(void)
{
	bakery_lock_init(&spm_lock);
}

void spm_lock_get(void)
{
	bakery_lock_get(&spm_lock);
}

void spm_lock_release(void)
{
	bakery_lock_release(&spm_lock);
}

#define SPM_FW_MAGIC    0x53504D32

static uint64_t spm_base_addr;
static uint64_t spm_base_size;
static int dyna_load_pcm_done = 1;
static char *dyna_load_pcm_path[] = {
	[DYNA_LOAD_PCM_SUSPEND_LP4_3733] = NULL, /* optional */
	[DYNA_LOAD_PCM_SUSPEND_LP4_3200] = "pcm_allinone_lp4_3200.bin",
	[DYNA_LOAD_PCM_SUSPEND_LP3_1866] = "pcm_allinone_lp3_1866.bin",
	[DYNA_LOAD_PCM_MAX] = "pcm_path_max",
};

struct dyna_load_pcm_t dyna_load_pcm[DYNA_LOAD_PCM_MAX];

#pragma pack(push)
#pragma pack(2)
struct spm_fw_header {
	unsigned int magic;
	unsigned int size;
	char name[58];
};
#pragma pack(pop)

char *spm_load_firmware(char *name)
{
	struct spm_fw_header *header;
	char *addr;

	addr = 0;
	header = (struct spm_fw_header *) spm_base_addr;

	while (header->magic == SPM_FW_MAGIC) {
		if (!strcmp(header->name, name))
			break;

		header = (struct spm_fw_header *) (((char *) header) + sizeof(*header) + header->size);
	}

	if (header->magic == SPM_FW_MAGIC) {
		addr = (((char *) header) + sizeof(*header));
		return addr;
	}

	return NULL;
}

int spm_load_pcm_firmware(void)
{
	int err = 0;
	int i;
	int cx;
	int offset = 0;
	int spm_fw_count = 0;

	if (dyna_load_pcm_done)
		return err;

	for (i = 0; i < DYNA_LOAD_PCM_MAX; i++) {
		uint16_t firmware_size = 0;
		int copy_size = 0;
		struct pcm_desc *pdesc = &(dyna_load_pcm[i].desc);
		char *ptr;

		/* Skip optional spmfw bin */
		if (dyna_load_pcm_path[i] == NULL) {
			spm_fw_count++;
			continue;
		}

		ptr = spm_load_firmware(dyna_load_pcm_path[i]);
		if (ptr == NULL) {
			ERROR("Failed to load %s, err = %d.\n", dyna_load_pcm_path[i], err);
			err = -1;
			continue;
		}

		/* Do whatever it takes to load firmware into device. */
		/* start of binary size */
		offset = 0;
		copy_size = 2;
		memcpy(&firmware_size, ptr + offset, copy_size);

		/* start of binary */
		offset += copy_size;
		copy_size = firmware_size * 4;
		dyna_load_pcm[i].buf = ptr + offset;

		/* start of pcm_desc without pointer */
		offset += copy_size;
		copy_size = sizeof(struct pcm_desc) - offsetof(struct pcm_desc, size);
		memcpy((void *)&(dyna_load_pcm[i].desc.size), ptr + offset, copy_size);

		/* start of pcm_desc version */
		offset += copy_size;
		cx = snprintf(dyna_load_pcm[i].version, PCM_FIRMWARE_VERSION_SIZE - 1,
				"%s", ptr + offset);
		if (cx < 0 || cx >= (PCM_FIRMWARE_VERSION_SIZE - 1))
			continue;

		pdesc->version = dyna_load_pcm[i].version;
		pdesc->base = (uint32_t *) dyna_load_pcm[i].buf;
		/* pdesc->base_dma = (uint64_t)dyna_load_pcm[i].buf; */

		INFO("#@# %s(%d) use spmfw partition for %s - %s\n", __func__, __LINE__,
				dyna_load_pcm_path[i], pdesc->version);

		dyna_load_pcm[i].ready = 1;
		spm_fw_count++;
	}

	if (spm_fw_count == DYNA_LOAD_PCM_MAX)
		dyna_load_pcm_done = 1;

	return err;
}

uint64_t spm_load_firmware_status(void)
{
	uint64_t bRet = 0;

	if (dyna_load_pcm_done) {
		bRet = SPM_FIRMWARE_STATUS_LOADED;
		if (mmio_read_32(PCM_REG15_DATA) != 0)
			bRet = SPM_FIRMWARE_STATUS_LOADED_KICKED;
	}
	return bRet;
}

void spm_irq0_handler(uint64_t x1)
{
	mmio_write_32(SPM_IRQ_MASK, mmio_read_32(SPM_IRQ_MASK) | ISRM_ALL_EXC_TWAM);
	mmio_write_32(SPM_IRQ_STA, x1);
	mmio_write_32(SPM_SWINT_CLR, PCM_SW_INT0);
}

void spm_ap_mdsrc_req(uint64_t x1)
{
	if (x1)
		mmio_write_32(AP_MDSRC_REQ, mmio_read_32(AP_MDSRC_REQ) | AP_MDSMSRC_REQ_LSB);
	else
		mmio_write_32(AP_MDSRC_REQ, mmio_read_32(AP_MDSRC_REQ) & ~AP_MDSMSRC_REQ_LSB);
}

/* code gen by spm_pwr_ctrl_atf.pl, need struct pwr_ctrl */
void save_pwr_ctrl(struct pwr_ctrl *pwrctrl, unsigned int index, unsigned int val)
{
	switch (index) {
	case PWR_PCM_FLAGS:
		pwrctrl->pcm_flags = val;
		break;
	case PWR_PCM_FLAGS_CUST:
		pwrctrl->pcm_flags_cust = val;
		break;
	case PWR_PCM_FLAGS_CUST_SET:
		pwrctrl->pcm_flags_cust_set = val;
		break;
	case PWR_PCM_FLAGS_CUST_CLR:
		pwrctrl->pcm_flags_cust_clr = val;
		break;
	case PWR_PCM_FLAGS1:
		pwrctrl->pcm_flags1 = val;
		break;
	case PWR_PCM_FLAGS1_CUST:
		pwrctrl->pcm_flags1_cust = val;
		break;
	case PWR_PCM_FLAGS1_CUST_SET:
		pwrctrl->pcm_flags1_cust_set = val;
		break;
	case PWR_PCM_FLAGS1_CUST_CLR:
		pwrctrl->pcm_flags1_cust_clr = val;
		break;
	case PWR_TIMER_VAL:
		pwrctrl->timer_val = val;
		break;
	case PWR_TIMER_VAL_CUST:
		pwrctrl->timer_val_cust = val;
		break;
	case PWR_TIMER_VAL_RAMP_EN:
		pwrctrl->timer_val_ramp_en = val;
		break;
	case PWR_TIMER_VAL_RAMP_EN_SEC:
		pwrctrl->timer_val_ramp_en_sec = val;
		break;
	case PWR_WAKE_SRC:
		pwrctrl->wake_src = val;
		break;
	case PWR_WAKE_SRC_CUST:
		pwrctrl->wake_src_cust = val;
		break;
	case PWR_WAKELOCK_TIMER_VAL:
		pwrctrl->wakelock_timer_val = val;
		break;
	case PWR_WDT_DISABLE:
		pwrctrl->wdt_disable = val;
		break;
	/* SPM_AP_STANDBY_CON */
	case PWR_WFI_OP:
		pwrctrl->wfi_op = val;
		break;
	case PWR_MP0_CPUTOP_IDLE_MASK:
		pwrctrl->mp0_cputop_idle_mask = val;
		break;
	case PWR_MP1_CPUTOP_IDLE_MASK:
		pwrctrl->mp1_cputop_idle_mask = val;
		break;
	case PWR_MCUSYS_IDLE_MASK:
		pwrctrl->mcusys_idle_mask = val;
		break;
	case PWR_MM_MASK_B:
		pwrctrl->mm_mask_b = val;
		break;
	case PWR_MD_DDR_EN_0_DBC_EN:
		pwrctrl->md_ddr_en_0_dbc_en = val;
		break;
	case PWR_MD_DDR_EN_1_DBC_EN:
		pwrctrl->md_ddr_en_1_dbc_en = val;
		break;
	case PWR_MD_MASK_B:
		pwrctrl->md_mask_b = val;
		break;
	case PWR_SSPM_MASK_B:
		pwrctrl->sspm_mask_b = val;
		break;
	case PWR_SCP_MASK_B:
		pwrctrl->scp_mask_b = val;
		break;
	case PWR_SRCCLKENI_MASK_B:
		pwrctrl->srcclkeni_mask_b = val;
		break;
	case PWR_MD_APSRC_1_SEL:
		pwrctrl->md_apsrc_1_sel = val;
		break;
	case PWR_MD_APSRC_0_SEL:
		pwrctrl->md_apsrc_0_sel = val;
		break;
	case PWR_CONN_DDR_EN_DBC_EN:
		pwrctrl->conn_ddr_en_dbc_en = val;
		break;
	case PWR_CONN_MASK_B:
		pwrctrl->conn_mask_b = val;
		break;
	case PWR_CONN_APSRC_SEL:
		pwrctrl->conn_apsrc_sel = val;
		break;
	case PWR_CONN_SRCCLKENA_SEL_MASK:
		pwrctrl->conn_srcclkena_sel_mask = val;
		break;
	/* SPM_SRC_REQ */
	case PWR_SPM_APSRC_REQ:
		pwrctrl->spm_apsrc_req = val;
		break;
	case PWR_SPM_F26M_REQ:
		pwrctrl->spm_f26m_req = val;
		break;
	case PWR_SPM_INFRA_REQ:
		pwrctrl->spm_infra_req = val;
		break;
	case PWR_SPM_VRF18_REQ:
		pwrctrl->spm_vrf18_req = val;
		break;
	case PWR_SPM_DDREN_REQ:
		pwrctrl->spm_ddren_req = val;
		break;
	case PWR_SPM_RSV_SRC_REQ:
		pwrctrl->spm_rsv_src_req = val;
		break;
	case PWR_SPM_DDREN_2_REQ:
		pwrctrl->spm_ddren_2_req = val;
		break;
	case PWR_CPU_MD_DVFS_SOP_FORCE_ON:
		pwrctrl->cpu_md_dvfs_sop_force_on = val;
		break;
	/* SPM_SRC_MASK */
	case PWR_CSYSPWREQ_MASK:
		pwrctrl->csyspwreq_mask = val;
		break;
	case PWR_CCIF0_MD_EVENT_MASK_B:
		pwrctrl->ccif0_md_event_mask_b = val;
		break;
	case PWR_CCIF0_AP_EVENT_MASK_B:
		pwrctrl->ccif0_ap_event_mask_b = val;
		break;
	case PWR_CCIF1_MD_EVENT_MASK_B:
		pwrctrl->ccif1_md_event_mask_b = val;
		break;
	case PWR_CCIF1_AP_EVENT_MASK_B:
		pwrctrl->ccif1_ap_event_mask_b = val;
		break;
	case PWR_CCIF2_MD_EVENT_MASK_B:
		pwrctrl->ccif2_md_event_mask_b = val;
		break;
	case PWR_CCIF2_AP_EVENT_MASK_B:
		pwrctrl->ccif2_ap_event_mask_b = val;
		break;
	case PWR_CCIF3_MD_EVENT_MASK_B:
		pwrctrl->ccif3_md_event_mask_b = val;
		break;
	case PWR_CCIF3_AP_EVENT_MASK_B:
		pwrctrl->ccif3_ap_event_mask_b = val;
		break;
	case PWR_MD_SRCCLKENA_0_INFRA_MASK_B:
		pwrctrl->md_srcclkena_0_infra_mask_b = val;
		break;
	case PWR_MD_SRCCLKENA_1_INFRA_MASK_B:
		pwrctrl->md_srcclkena_1_infra_mask_b = val;
		break;
	case PWR_CONN_SRCCLKENA_INFRA_MASK_B:
		pwrctrl->conn_srcclkena_infra_mask_b = val;
		break;
	case PWR_UFS_INFRA_REQ_MASK_B:
		pwrctrl->ufs_infra_req_mask_b = val;
		break;
	case PWR_SRCCLKENI_INFRA_MASK_B:
		pwrctrl->srcclkeni_infra_mask_b = val;
		break;
	case PWR_MD_APSRC_REQ_0_INFRA_MASK_B:
		pwrctrl->md_apsrc_req_0_infra_mask_b = val;
		break;
	case PWR_MD_APSRC_REQ_1_INFRA_MASK_B:
		pwrctrl->md_apsrc_req_1_infra_mask_b = val;
		break;
	case PWR_CONN_APSRCREQ_INFRA_MASK_B:
		pwrctrl->conn_apsrcreq_infra_mask_b = val;
		break;
	case PWR_UFS_SRCCLKENA_MASK_B:
		pwrctrl->ufs_srcclkena_mask_b = val;
		break;
	case PWR_MD_VRF18_REQ_0_MASK_B:
		pwrctrl->md_vrf18_req_0_mask_b = val;
		break;
	case PWR_MD_VRF18_REQ_1_MASK_B:
		pwrctrl->md_vrf18_req_1_mask_b = val;
		break;
	case PWR_UFS_VRF18_REQ_MASK_B:
		pwrctrl->ufs_vrf18_req_mask_b = val;
		break;
	case PWR_GCE_VRF18_REQ_MASK_B:
		pwrctrl->gce_vrf18_req_mask_b = val;
		break;
	case PWR_CONN_INFRA_REQ_MASK_B:
		pwrctrl->conn_infra_req_mask_b = val;
		break;
	case PWR_GCE_APSRC_REQ_MASK_B:
		pwrctrl->gce_apsrc_req_mask_b = val;
		break;
	case PWR_DISP0_APSRC_REQ_MASK_B:
		pwrctrl->disp0_apsrc_req_mask_b = val;
		break;
	case PWR_DISP1_APSRC_REQ_MASK_B:
		pwrctrl->disp1_apsrc_req_mask_b = val;
		break;
	case PWR_MFG_REQ_MASK_B:
		pwrctrl->mfg_req_mask_b = val;
		break;
	case PWR_VDEC_REQ_MASK_B:
		pwrctrl->vdec_req_mask_b = val;
		break;
	case PWR_MCU_APSRCREQ_INFRA_MASK_B:
		pwrctrl->mcu_apsrcreq_infra_mask_b = val;
		break;
	/* SPM_SRC2_MASK */
	case PWR_MD_DDR_EN_0_MASK_B:
		pwrctrl->md_ddr_en_0_mask_b = val;
		break;
	case PWR_MD_DDR_EN_1_MASK_B:
		pwrctrl->md_ddr_en_1_mask_b = val;
		break;
	case PWR_CONN_DDR_EN_MASK_B:
		pwrctrl->conn_ddr_en_mask_b = val;
		break;
	case PWR_DDREN_MD32_APSRC_REQ_MASK_B:
		pwrctrl->ddren_md32_apsrc_req_mask_b = val;
		break;
	case PWR_DDREN_SCP_APSRC_REQ_MASK_B:
		pwrctrl->ddren_scp_apsrc_req_mask_b = val;
		break;
	case PWR_DISP0_DDREN_MASK_B:
		pwrctrl->disp0_ddren_mask_b = val;
		break;
	case PWR_DISP1_DDREN_MASK_B:
		pwrctrl->disp1_ddren_mask_b = val;
		break;
	case PWR_GCE_DDREN_MASK_B:
		pwrctrl->gce_ddren_mask_b = val;
		break;
	case PWR_DDREN_EMI_SELF_REFRESH_CH0_MASK_B:
		pwrctrl->ddren_emi_self_refresh_ch0_mask_b = val;
		break;
	case PWR_DDREN_EMI_SELF_REFRESH_CH1_MASK_B:
		pwrctrl->ddren_emi_self_refresh_ch1_mask_b = val;
		break;
	case PWR_MCU_APSRC_REQ_MASK_B:
		pwrctrl->mcu_apsrc_req_mask_b = val;
		break;
	case PWR_MCU_DDREN_MASK_B:
		pwrctrl->mcu_ddren_mask_b = val;
		break;
	/* SPM_WAKEUP_EVENT_MASK */
	case PWR_SPM_WAKEUP_EVENT_MASK:
		pwrctrl->spm_wakeup_event_mask = val;
		break;
	/* SPM_WAKEUP_EVENT_EXT_MASK */
	case PWR_SPM_WAKEUP_EVENT_EXT_MASK:
		pwrctrl->spm_wakeup_event_ext_mask = val;
		break;
	/* SPM_SRC3_MASK */
	case PWR_MD_DDR_EN_2_0_MASK_B:
		pwrctrl->md_ddr_en_2_0_mask_b = val;
		break;
	case PWR_MD_DDR_EN_2_1_MASK_B:
		pwrctrl->md_ddr_en_2_1_mask_b = val;
		break;
	case PWR_CONN_DDR_EN_2_MASK_B:
		pwrctrl->conn_ddr_en_2_mask_b = val;
		break;
	case PWR_DDREN2_MD32_APSRC_REQ_MASK_B:
		pwrctrl->ddren2_md32_apsrc_req_mask_b = val;
		break;
	case PWR_DDREN2_SCP_APSRC_REQ_MASK_B:
		pwrctrl->ddren2_scp_apsrc_req_mask_b = val;
		break;
	case PWR_DISP0_DDREN2_MASK_B:
		pwrctrl->disp0_ddren2_mask_b = val;
		break;
	case PWR_DISP1_DDREN2_MASK_B:
		pwrctrl->disp1_ddren2_mask_b = val;
		break;
	case PWR_GCE_DDREN2_MASK_B:
		pwrctrl->gce_ddren2_mask_b = val;
		break;
	case PWR_DDREN2_EMI_SELF_REFRESH_CH0_MASK_B:
		pwrctrl->ddren2_emi_self_refresh_ch0_mask_b = val;
		break;
	case PWR_DDREN2_EMI_SELF_REFRESH_CH1_MASK_B:
		pwrctrl->ddren2_emi_self_refresh_ch1_mask_b = val;
		break;
	case PWR_MCU_DDREN_2_MASK_B:
		pwrctrl->mcu_ddren_2_mask_b = val;
		break;
	/* SPARE_SRC_REQ_MASK */
	case PWR_SPARE1_DDREN_MASK_B:
		pwrctrl->spare1_ddren_mask_b = val;
		break;
	case PWR_SPARE1_APSRC_REQ_MASK_B:
		pwrctrl->spare1_apsrc_req_mask_b = val;
		break;
	case PWR_SPARE1_VRF18_REQ_MASK_B:
		pwrctrl->spare1_vrf18_req_mask_b = val;
		break;
	case PWR_SPARE1_INFRA_REQ_MASK_B:
		pwrctrl->spare1_infra_req_mask_b = val;
		break;
	case PWR_SPARE1_SRCCLKENA_MASK_B:
		pwrctrl->spare1_srcclkena_mask_b = val;
		break;
	case PWR_SPARE1_DDREN2_MASK_B:
		pwrctrl->spare1_ddren2_mask_b = val;
		break;
	case PWR_SPARE2_DDREN_MASK_B:
		pwrctrl->spare2_ddren_mask_b = val;
		break;
	case PWR_SPARE2_APSRC_REQ_MASK_B:
		pwrctrl->spare2_apsrc_req_mask_b = val;
		break;
	case PWR_SPARE2_VRF18_REQ_MASK_B:
		pwrctrl->spare2_vrf18_req_mask_b = val;
		break;
	case PWR_SPARE2_INFRA_REQ_MASK_B:
		pwrctrl->spare2_infra_req_mask_b = val;
		break;
	case PWR_SPARE2_SRCCLKENA_MASK_B:
		pwrctrl->spare2_srcclkena_mask_b = val;
		break;
	case PWR_SPARE2_DDREN2_MASK_B:
		pwrctrl->spare2_ddren2_mask_b = val;
		break;
	/* MP0_CPU0_WFI_EN */
	case PWR_MP0_CPU0_WFI_EN:
		pwrctrl->mp0_cpu0_wfi_en = val;
		break;
	/* MP0_CPU1_WFI_EN */
	case PWR_MP0_CPU1_WFI_EN:
		pwrctrl->mp0_cpu1_wfi_en = val;
		break;
	/* MP0_CPU2_WFI_EN */
	case PWR_MP0_CPU2_WFI_EN:
		pwrctrl->mp0_cpu2_wfi_en = val;
		break;
	/* MP0_CPU3_WFI_EN */
	case PWR_MP0_CPU3_WFI_EN:
		pwrctrl->mp0_cpu3_wfi_en = val;
		break;
	/* MP1_CPU0_WFI_EN */
	case PWR_MP1_CPU0_WFI_EN:
		pwrctrl->mp1_cpu0_wfi_en = val;
		break;
	/* MP1_CPU1_WFI_EN */
	case PWR_MP1_CPU1_WFI_EN:
		pwrctrl->mp1_cpu1_wfi_en = val;
		break;
	/* MP1_CPU2_WFI_EN */
	case PWR_MP1_CPU2_WFI_EN:
		pwrctrl->mp1_cpu2_wfi_en = val;
		break;
	/* MP1_CPU3_WFI_EN */
	case PWR_MP1_CPU3_WFI_EN:
		pwrctrl->mp1_cpu3_wfi_en = val;
		break;
	/* IDLE CONTROL */
	case PWR_IDLE_SWITCH:
		pwrctrl->idle_switch = val;
		break;
	case PWR_BY_SWT:
		pwrctrl->by_swt = val;
		break;
	case PWR_BY_BOOT:
		pwrctrl->by_boot = val;
		break;
	case PWR_BY_CPU:
		pwrctrl->by_cpu = val;
		break;
	case PWR_BY_CLK:
		pwrctrl->by_clk = val;
		break;
	case PWR_BY_GPT:
		pwrctrl->by_gpt = val;
		break;
	case PWR_CPU0_CNT:
		pwrctrl->cpu_cnt[0] = val;
		break;
	case PWR_CPU1_CNT:
		pwrctrl->cpu_cnt[1] = val;
		break;
	case PWR_CPU2_CNT:
		pwrctrl->cpu_cnt[2] = val;
		break;
	case PWR_CPU3_CNT:
		pwrctrl->cpu_cnt[3] = val;
		break;
	case PWR_INFRA1_IDLE_MASK:
		pwrctrl->infra1_idle_mask = val;
		break;
	case PWR_INFRA0_IDLE_MASK:
		pwrctrl->infra0_idle_mask = val;
		break;
	case PWR_INFRA2_IDLE_MASK:
		pwrctrl->infra2_idle_mask = val;
		break;
	case PWR_INFRA3_IDLE_MASK:
		pwrctrl->infra3_idle_mask = val;
		break;
	case PWR_INFRA4_IDLE_MASK:
		pwrctrl->infra4_idle_mask = val;
		break;
	case PWR_MMSYS0_IDLE_MASK:
		pwrctrl->mmsys0_idle_mask = val;
		break;
	case PWR_MMSYS1_IDLE_MASK:
		pwrctrl->mmsys1_idle_mask = val;
		break;
	case PWR_CAM_IDLE_MASK:
		pwrctrl->cam_idle_mask = val;
		break;
	case PWR_MFG_IDLE_MASK:
		pwrctrl->mfg_idle_mask = val;
		break;
	case PWR_VENC_IDLE_MASK:
		pwrctrl->venc_idle_mask = val;
		break;
	case PWR_VDEC_IDLE_MASK:
		pwrctrl->vdec_idle_mask = val;
		break;
	case PWR_APU_IDLE_MASK:
		pwrctrl->apu_idle_mask = val;
		break;
	case PWR_LOG_EN:
		pwrctrl->log_en = val;
		break;
	case PWR_PCM_ADD_FAKE_26M_FLAG:
		pwrctrl->pcm_flags |= SPM_FLAG_FAKE_26M_FUNC;
		break;
	case PWR_PCM_REMOVE_FAKE_26M_FLAG:
		pwrctrl->pcm_flags &= ~SPM_FLAG_FAKE_26M_FUNC;
		break;
	case PWR_PCM_ADD_FLAG1_DIS_TOP_26M_CLK_OFF:
		pwrctrl->pcm_flags1 |= SPM_FLAG1_DIS_TOP_26M_CLK_OFF;
		break;
	case PWR_PCM_REMOVE_FLAG1_DIS_TOP_26M_CLK_OFF:
		pwrctrl->pcm_flags1 &= ~SPM_FLAG1_DIS_TOP_26M_CLK_OFF;
		break;
	case PWR_PCM_ADD_FLAG1_SWITCH_TO_ULPLL:
		pwrctrl->pcm_flags1 |= SPM_FLAG1_SWITCH_TO_ULPLL;
		break;
	case PWR_PCM_REMOVE_FLAG1_SWITCH_TO_ULPLL:
		pwrctrl->pcm_flags1 &= ~SPM_FLAG1_SWITCH_TO_ULPLL;
		break;
	default:

			ERROR("%s: %d is undefined!!!\n", __func__, index);
	}
}

/* code gen by spm_pwr_ctrl_atf.pl, need struct pwr_ctrl */
unsigned int load_pwr_ctrl(struct pwr_ctrl *pwrctrl, unsigned int index)
{
	unsigned int val = 0;

	switch (index) {
	case PWR_PCM_FLAGS:
		val = pwrctrl->pcm_flags;
		break;
	case PWR_PCM_FLAGS_CUST:
		val = pwrctrl->pcm_flags_cust;
		break;
	case PWR_PCM_FLAGS_CUST_SET:
		val = pwrctrl->pcm_flags_cust_set;
		break;
	case PWR_PCM_FLAGS_CUST_CLR:
		val = pwrctrl->pcm_flags_cust_clr;
		break;
	case PWR_PCM_FLAGS1:
		val = pwrctrl->pcm_flags1;
		break;
	case PWR_PCM_FLAGS1_CUST:
		val = pwrctrl->pcm_flags1_cust;
		break;
	case PWR_PCM_FLAGS1_CUST_SET:
		val = pwrctrl->pcm_flags1_cust_set;
		break;
	case PWR_PCM_FLAGS1_CUST_CLR:
		val = pwrctrl->pcm_flags1_cust_clr;
		break;
	case PWR_TIMER_VAL:
		val = pwrctrl->timer_val;
		break;
	case PWR_TIMER_VAL_CUST:
		val = pwrctrl->timer_val_cust;
		break;
	case PWR_TIMER_VAL_RAMP_EN:
		val = pwrctrl->timer_val_ramp_en;
		break;
	case PWR_TIMER_VAL_RAMP_EN_SEC:
		val = pwrctrl->timer_val_ramp_en_sec;
		break;
	case PWR_WAKE_SRC:
		val = pwrctrl->wake_src;
		break;
	case PWR_WAKE_SRC_CUST:
		val = pwrctrl->wake_src_cust;
		break;
	case PWR_WAKELOCK_TIMER_VAL:
		val = pwrctrl->wakelock_timer_val;
		break;
	case PWR_WDT_DISABLE:
		val = pwrctrl->wdt_disable;
		break;
	/* SPM_AP_STANDBY_CON */
	case PWR_WFI_OP:
		val = pwrctrl->wfi_op;
		break;
	case PWR_MP0_CPUTOP_IDLE_MASK:
		val = pwrctrl->mp0_cputop_idle_mask;
		break;
	case PWR_MP1_CPUTOP_IDLE_MASK:
		val = pwrctrl->mp1_cputop_idle_mask;
		break;
	case PWR_MCUSYS_IDLE_MASK:
		val = pwrctrl->mcusys_idle_mask;
		break;
	case PWR_MM_MASK_B:
		val = pwrctrl->mm_mask_b;
		break;
	case PWR_MD_DDR_EN_0_DBC_EN:
		val = pwrctrl->md_ddr_en_0_dbc_en;
		break;
	case PWR_MD_DDR_EN_1_DBC_EN:
		val = pwrctrl->md_ddr_en_1_dbc_en;
		break;
	case PWR_MD_MASK_B:
		val = pwrctrl->md_mask_b;
		break;
	case PWR_SSPM_MASK_B:
		val = pwrctrl->sspm_mask_b;
		break;
	case PWR_SCP_MASK_B:
		val = pwrctrl->scp_mask_b;
		break;
	case PWR_SRCCLKENI_MASK_B:
		val = pwrctrl->srcclkeni_mask_b;
		break;
	case PWR_MD_APSRC_1_SEL:
		val = pwrctrl->md_apsrc_1_sel;
		break;
	case PWR_MD_APSRC_0_SEL:
		val = pwrctrl->md_apsrc_0_sel;
		break;
	case PWR_CONN_DDR_EN_DBC_EN:
		val = pwrctrl->conn_ddr_en_dbc_en;
		break;
	case PWR_CONN_MASK_B:
		val = pwrctrl->conn_mask_b;
		break;
	case PWR_CONN_APSRC_SEL:
		val = pwrctrl->conn_apsrc_sel;
		break;
	case PWR_CONN_SRCCLKENA_SEL_MASK:
		val = pwrctrl->conn_srcclkena_sel_mask;
		break;
		/* SPM_SRC_REQ */
	case PWR_SPM_APSRC_REQ:
		val = pwrctrl->spm_apsrc_req;
		break;
	case PWR_SPM_F26M_REQ:
		val = pwrctrl->spm_f26m_req;
		break;
	case PWR_SPM_INFRA_REQ:
		val = pwrctrl->spm_infra_req;
		break;
	case PWR_SPM_VRF18_REQ:
		val = pwrctrl->spm_vrf18_req;
		break;
	case PWR_SPM_DDREN_REQ:
		val = pwrctrl->spm_ddren_req;
		break;
	case PWR_SPM_RSV_SRC_REQ:
		val = pwrctrl->spm_rsv_src_req;
		break;
	case PWR_SPM_DDREN_2_REQ:
		val = pwrctrl->spm_ddren_2_req;
		break;
	case PWR_CPU_MD_DVFS_SOP_FORCE_ON:
		val = pwrctrl->cpu_md_dvfs_sop_force_on;
		break;
	/* SPM_SRC_MASK */
	case PWR_CSYSPWREQ_MASK:
		val = pwrctrl->csyspwreq_mask;
		break;
	case PWR_CCIF0_MD_EVENT_MASK_B:
		val = pwrctrl->ccif0_md_event_mask_b;
		break;
	case PWR_CCIF0_AP_EVENT_MASK_B:
		val = pwrctrl->ccif0_ap_event_mask_b;
		break;
	case PWR_CCIF1_MD_EVENT_MASK_B:
		val = pwrctrl->ccif1_md_event_mask_b;
		break;
	case PWR_CCIF1_AP_EVENT_MASK_B:
		val = pwrctrl->ccif1_ap_event_mask_b;
		break;
	case PWR_CCIF2_MD_EVENT_MASK_B:
		val = pwrctrl->ccif2_md_event_mask_b;
		break;
	case PWR_CCIF2_AP_EVENT_MASK_B:
		val = pwrctrl->ccif2_ap_event_mask_b;
		break;
	case PWR_CCIF3_MD_EVENT_MASK_B:
		val = pwrctrl->ccif3_md_event_mask_b;
		break;
	case PWR_CCIF3_AP_EVENT_MASK_B:
		val = pwrctrl->ccif3_ap_event_mask_b;
		break;
	case PWR_MD_SRCCLKENA_0_INFRA_MASK_B:
		val = pwrctrl->md_srcclkena_0_infra_mask_b;
		break;
	case PWR_MD_SRCCLKENA_1_INFRA_MASK_B:
		val = pwrctrl->md_srcclkena_1_infra_mask_b;
		break;
	case PWR_CONN_SRCCLKENA_INFRA_MASK_B:
		val = pwrctrl->conn_srcclkena_infra_mask_b;
		break;
	case PWR_UFS_INFRA_REQ_MASK_B:
		val = pwrctrl->ufs_infra_req_mask_b;
		break;
	case PWR_SRCCLKENI_INFRA_MASK_B:
		val = pwrctrl->srcclkeni_infra_mask_b;
		break;
	case PWR_MD_APSRC_REQ_0_INFRA_MASK_B:
		val = pwrctrl->md_apsrc_req_0_infra_mask_b;
		break;
	case PWR_MD_APSRC_REQ_1_INFRA_MASK_B:
		val = pwrctrl->md_apsrc_req_1_infra_mask_b;
		break;
	case PWR_CONN_APSRCREQ_INFRA_MASK_B:
		val = pwrctrl->conn_apsrcreq_infra_mask_b;
		break;
	case PWR_UFS_SRCCLKENA_MASK_B:
		val = pwrctrl->ufs_srcclkena_mask_b;
		break;
	case PWR_MD_VRF18_REQ_0_MASK_B:
		val = pwrctrl->md_vrf18_req_0_mask_b;
		break;
	case PWR_MD_VRF18_REQ_1_MASK_B:
		val = pwrctrl->md_vrf18_req_1_mask_b;
		break;
	case PWR_UFS_VRF18_REQ_MASK_B:
		val = pwrctrl->ufs_vrf18_req_mask_b;
		break;
	case PWR_GCE_VRF18_REQ_MASK_B:
		val = pwrctrl->gce_vrf18_req_mask_b;
		break;
	case PWR_CONN_INFRA_REQ_MASK_B:
		val = pwrctrl->conn_infra_req_mask_b;
		break;
	case PWR_GCE_APSRC_REQ_MASK_B:
		val = pwrctrl->gce_apsrc_req_mask_b;
		break;
	case PWR_DISP0_APSRC_REQ_MASK_B:
		val = pwrctrl->disp0_apsrc_req_mask_b;
		break;
	case PWR_DISP1_APSRC_REQ_MASK_B:
		val = pwrctrl->disp1_apsrc_req_mask_b;
		break;
	case PWR_MFG_REQ_MASK_B:
		val = pwrctrl->mfg_req_mask_b;
		break;
	case PWR_VDEC_REQ_MASK_B:
		val = pwrctrl->vdec_req_mask_b;
		break;
	case PWR_MCU_APSRCREQ_INFRA_MASK_B:
		val = pwrctrl->mcu_apsrcreq_infra_mask_b;
		break;
	/* SPM_SRC2_MASK */
	case PWR_MD_DDR_EN_0_MASK_B:
		val = pwrctrl->md_ddr_en_0_mask_b;
		break;
	case PWR_MD_DDR_EN_1_MASK_B:
		val = pwrctrl->md_ddr_en_1_mask_b;
		break;
	case PWR_CONN_DDR_EN_MASK_B:
		val = pwrctrl->conn_ddr_en_mask_b;
		break;
	case PWR_DDREN_MD32_APSRC_REQ_MASK_B:
		val = pwrctrl->ddren_md32_apsrc_req_mask_b;
		break;
	case PWR_DDREN_SCP_APSRC_REQ_MASK_B:
		val = pwrctrl->ddren_scp_apsrc_req_mask_b;
		break;
	case PWR_DISP0_DDREN_MASK_B:
		val = pwrctrl->disp0_ddren_mask_b;
		break;
	case PWR_DISP1_DDREN_MASK_B:
		val = pwrctrl->disp1_ddren_mask_b;
		break;
	case PWR_GCE_DDREN_MASK_B:
		val = pwrctrl->gce_ddren_mask_b;
		break;
	case PWR_DDREN_EMI_SELF_REFRESH_CH0_MASK_B:
		val = pwrctrl->ddren_emi_self_refresh_ch0_mask_b;
		break;
	case PWR_DDREN_EMI_SELF_REFRESH_CH1_MASK_B:
		val = pwrctrl->ddren_emi_self_refresh_ch1_mask_b;
		break;
	case PWR_MCU_APSRC_REQ_MASK_B:
		val = pwrctrl->mcu_apsrc_req_mask_b;
		break;
	case PWR_MCU_DDREN_MASK_B:
		val = pwrctrl->mcu_ddren_mask_b;
		break;
	/* SPM_WAKEUP_EVENT_MASK */
	case PWR_SPM_WAKEUP_EVENT_MASK:
		val = pwrctrl->spm_wakeup_event_mask;
		break;
	/* SPM_WAKEUP_EVENT_EXT_MASK */
	case PWR_SPM_WAKEUP_EVENT_EXT_MASK:
		val = pwrctrl->spm_wakeup_event_ext_mask;
		break;
	/* SPM_SRC3_MASK */
	case PWR_MD_DDR_EN_2_0_MASK_B:
		val = pwrctrl->md_ddr_en_2_0_mask_b;
		break;
	case PWR_MD_DDR_EN_2_1_MASK_B:
		val = pwrctrl->md_ddr_en_2_1_mask_b;
		break;
	case PWR_CONN_DDR_EN_2_MASK_B:
		val = pwrctrl->conn_ddr_en_2_mask_b;
		break;
	case PWR_DDREN2_MD32_APSRC_REQ_MASK_B:
		val = pwrctrl->ddren2_md32_apsrc_req_mask_b;
		break;
	case PWR_DDREN2_SCP_APSRC_REQ_MASK_B:
		val = pwrctrl->ddren2_scp_apsrc_req_mask_b;
		break;
	case PWR_DISP0_DDREN2_MASK_B:
		val = pwrctrl->disp0_ddren2_mask_b;
		break;
	case PWR_DISP1_DDREN2_MASK_B:
		val = pwrctrl->disp1_ddren2_mask_b;
		break;
	case PWR_GCE_DDREN2_MASK_B:
		val = pwrctrl->gce_ddren2_mask_b;
		break;
	case PWR_DDREN2_EMI_SELF_REFRESH_CH0_MASK_B:
		val = pwrctrl->ddren2_emi_self_refresh_ch0_mask_b;
		break;
	case PWR_DDREN2_EMI_SELF_REFRESH_CH1_MASK_B:
		val = pwrctrl->ddren2_emi_self_refresh_ch1_mask_b;
		break;
	case PWR_MCU_DDREN_2_MASK_B:
		val = pwrctrl->mcu_ddren_2_mask_b;
		break;
	/* SPARE_SRC_REQ_MASK */
	case PWR_SPARE1_DDREN_MASK_B:
		val = pwrctrl->spare1_ddren_mask_b;
		break;
	case PWR_SPARE1_APSRC_REQ_MASK_B:
		val = pwrctrl->spare1_apsrc_req_mask_b;
		break;
	case PWR_SPARE1_VRF18_REQ_MASK_B:
		val = pwrctrl->spare1_vrf18_req_mask_b;
		break;
	case PWR_SPARE1_INFRA_REQ_MASK_B:
		val = pwrctrl->spare1_infra_req_mask_b;
		break;
	case PWR_SPARE1_SRCCLKENA_MASK_B:
		val = pwrctrl->spare1_srcclkena_mask_b;
		break;
	case PWR_SPARE1_DDREN2_MASK_B:
		val = pwrctrl->spare1_ddren2_mask_b;
		break;
	case PWR_SPARE2_DDREN_MASK_B:
		val = pwrctrl->spare2_ddren_mask_b;
		break;
	case PWR_SPARE2_APSRC_REQ_MASK_B:
		val = pwrctrl->spare2_apsrc_req_mask_b;
		break;
	case PWR_SPARE2_VRF18_REQ_MASK_B:
		val = pwrctrl->spare2_vrf18_req_mask_b;
		break;
	case PWR_SPARE2_INFRA_REQ_MASK_B:
		val = pwrctrl->spare2_infra_req_mask_b;
		break;
	case PWR_SPARE2_SRCCLKENA_MASK_B:
		val = pwrctrl->spare2_srcclkena_mask_b;
		break;
	case PWR_SPARE2_DDREN2_MASK_B:
		val = pwrctrl->spare2_ddren2_mask_b;
		break;
	/* MP0_CPU0_WFI_EN */
	case PWR_MP0_CPU0_WFI_EN:
		val = pwrctrl->mp0_cpu0_wfi_en;
		break;
	/* MP0_CPU1_WFI_EN */
	case PWR_MP0_CPU1_WFI_EN:
		val = pwrctrl->mp0_cpu1_wfi_en;
		break;
	/* MP0_CPU2_WFI_EN */
	case PWR_MP0_CPU2_WFI_EN:
		val = pwrctrl->mp0_cpu2_wfi_en;
		break;
	/* MP0_CPU3_WFI_EN */
	case PWR_MP0_CPU3_WFI_EN:
		val = pwrctrl->mp0_cpu3_wfi_en;
		break;
	/* MP1_CPU0_WFI_EN */
	case PWR_MP1_CPU0_WFI_EN:
		val = pwrctrl->mp1_cpu0_wfi_en;
		break;
	/* MP1_CPU1_WFI_EN */
	case PWR_MP1_CPU1_WFI_EN:
		val = pwrctrl->mp1_cpu1_wfi_en;
		break;
	/* MP1_CPU2_WFI_EN */
	case PWR_MP1_CPU2_WFI_EN:
		val = pwrctrl->mp1_cpu2_wfi_en;
		break;
	/* MP1_CPU3_WFI_EN */
	case PWR_MP1_CPU3_WFI_EN:
		val = pwrctrl->mp1_cpu3_wfi_en;
		break;
	/* IDLE CONTROL */
	case PWR_IDLE_SWITCH:
		val = pwrctrl->idle_switch;
		break;
	case PWR_BY_SWT:
		val = pwrctrl->by_swt;
		break;
	case PWR_BY_BOOT:
		val = pwrctrl->by_boot;
		break;
	case PWR_BY_CPU:
		val = pwrctrl->by_cpu;
		break;
	case PWR_BY_CLK:
		val = pwrctrl->by_clk;
		break;
	case PWR_BY_GPT:
		val = pwrctrl->by_gpt;
		break;
	case PWR_CPU0_CNT:
		val = pwrctrl->cpu_cnt[0];
		break;
	case PWR_CPU1_CNT:
		val = pwrctrl->cpu_cnt[1];
		break;
	case PWR_CPU2_CNT:
		val = pwrctrl->cpu_cnt[2];
		break;
	case PWR_CPU3_CNT:
		val = pwrctrl->cpu_cnt[3];
		break;
	case PWR_INFRA1_IDLE_MASK:
		val = pwrctrl->infra1_idle_mask;
		break;
	case PWR_INFRA0_IDLE_MASK:
		val = pwrctrl->infra0_idle_mask;
		break;
	case PWR_INFRA2_IDLE_MASK:
		val = pwrctrl->infra2_idle_mask;
		break;
	case PWR_INFRA3_IDLE_MASK:
		val = pwrctrl->infra3_idle_mask;
		break;
	case PWR_INFRA4_IDLE_MASK:
		val = pwrctrl->infra4_idle_mask;
		break;
	case PWR_MMSYS0_IDLE_MASK:
		val = pwrctrl->mmsys0_idle_mask;
		break;
	case PWR_MMSYS1_IDLE_MASK:
		val = pwrctrl->mmsys1_idle_mask;
		break;
	case PWR_CAM_IDLE_MASK:
		val = pwrctrl->cam_idle_mask;
		break;
	case PWR_MFG_IDLE_MASK:
		val = pwrctrl->mfg_idle_mask;
		break;
	case PWR_VENC_IDLE_MASK:
		val = pwrctrl->venc_idle_mask;
		break;
	case PWR_VDEC_IDLE_MASK:
		val = pwrctrl->vdec_idle_mask;
		break;
	case PWR_APU_IDLE_MASK:
		val = pwrctrl->apu_idle_mask;
		break;
	case PWR_INFRA1_IDLE_RG:
		val = spm_get_infra1_sta();
		break;
	case PWR_INFRA0_IDLE_RG:
		val = spm_get_infra0_sta();
		break;
	case PWR_INFRA2_IDLE_RG:
		val = spm_get_infra2_sta();
		break;
	case PWR_INFRA3_IDLE_RG:
		val = spm_get_infra3_sta();
		break;
	case PWR_INFRA4_IDLE_RG:
		val = spm_get_infra4_sta();
		break;
	case PWR_MMSYS0_IDLE_RG:
		val = spm_get_mmsys_con0();
		break;
	case PWR_MMSYS1_IDLE_RG:
		val = spm_get_mmsys_con1();
		break;
	case PWR_CAM_IDLE_RG:
		val = spm_get_cam_pow_con();
		break;
	case PWR_MFG_IDLE_RG:
		val = spm_get_mfg_pow_con();
		break;
	case PWR_VENC_IDLE_RG:
		val = spm_get_venc_pow_con();
		break;
	case PWR_VDEC_IDLE_RG:
		val = spm_get_vdec_pow_con();
		break;
	case PWR_APU_IDLE_RG:
		val = spm_get_apu_pow_con();
		break;
	case PWR_LOG_EN:
		val = pwrctrl->log_en;
		break;
	default:
			ERROR("%s: %d is undefined!!!\n", __func__, index);
	}

	return val;
}

void spm_pwr_ctrl_args(uint64_t x1, uint64_t x2, uint64_t x3)
{
	switch (x1) {
	case SPM_PWR_CTRL_SUSPEND:
		save_pwr_ctrl(__spm_suspend.pwrctrl, x2, x3);
		break;
	case SPM_PWR_CTRL_DPIDLE:
		save_pwr_ctrl(__spm_dpidle.pwrctrl, x2, x3);
		break;
	case SPM_PWR_CTRL_SODI:
		save_pwr_ctrl(__spm_sodi.pwrctrl, x2, x3);
		break;
	case SPM_PWR_CTRL_SODI3:
		save_pwr_ctrl(__spm_sodi.pwrctrl, x2, x3);
		break;
	case SPM_PWR_CTRL_VCOREFS:
		save_pwr_ctrl(__spm_vcorefs.pwrctrl, x2, x3);
		break;
	}
}

uint64_t spm_get_pwr_ctrl_args(uint64_t x1, uint64_t x2, uint64_t x3)
{
	uint64_t ret = 0;

	switch (x1) {
	case SPM_PWR_CTRL_SUSPEND:
		ret = load_pwr_ctrl(__spm_suspend.pwrctrl, x2);
		break;
	case SPM_PWR_CTRL_DPIDLE:
		ret = load_pwr_ctrl(__spm_dpidle.pwrctrl, x2);
		break;
	case SPM_PWR_CTRL_SODI:
		ret = load_pwr_ctrl(__spm_sodi.pwrctrl, x2);
		break;
	case SPM_PWR_CTRL_SODI3:
		ret = load_pwr_ctrl(__spm_sodi.pwrctrl, x2);
		break;
	case SPM_PWR_CTRL_VCOREFS:
		ret = load_pwr_ctrl(__spm_vcorefs.pwrctrl, x2);
		break;
	}

	return ret;
}

void spm_dcs_s1_setting(uint64_t x1, uint64_t x2)
{
	/* FIXME: */
#if 0
	uint32_t enable = x1;
	uint32_t flags = x2;

	mmio_write_32(DRAMC_DPY_CLK_SW_CON5, mmio_read_32(DRAMC_DPY_CLK_SW_CON5) | flags);
	while ((mmio_read_32(DRAMC_DPY_CLK_SW_CON5) & (0xf << 4)) != (flags << 4))
		;

	if (!!enable)
		mmio_write_32(SPM_SPARE_CON_SET, flags << 24);
	else
		mmio_write_32(SPM_SPARE_CON_CLR, flags << 24);

	mmio_write_32(DRAMC_DPY_CLK_SW_CON5, mmio_read_32(DRAMC_DPY_CLK_SW_CON5) & ~flags);
	while ((mmio_read_32(DRAMC_DPY_CLK_SW_CON5) & (0xf << 4)) != 0)
		;
#endif
}

void spm_dummy_read(uint64_t x1, uint64_t x2)
{
	/* FIXME: */
#if 0
	uint32_t rank0_addr = x1;
	uint32_t rank1_addr = x2;

	mmio_write_32(SPM_PASR_DPD_2, rank0_addr & 0xffffffff);
	mmio_write_32(SPM_PASR_DPD_3, rank1_addr & 0xffffffff);
	if ((x1 >> 32) & 0x1)
		mmio_write_32(SPM_SW_RSV_5, mmio_read_32(SPM_SW_RSV_5) | (1 << 3));
	else
		mmio_write_32(SPM_SW_RSV_5, mmio_read_32(SPM_SW_RSV_5) & ~(1 << 3));
	if ((x2 >> 32) & 0x1)
		mmio_write_32(SPM_SW_RSV_5, mmio_read_32(SPM_SW_RSV_5) | (1 << 4));
	else
		mmio_write_32(SPM_SW_RSV_5, mmio_read_32(SPM_SW_RSV_5) & ~(1 << 4));
#endif
}

uint32_t __spmfw_idx;
uint32_t is_ext_buck;

void spm_args(uint64_t x1, uint64_t x2, uint64_t x3)
{
	uint64_t cmd = x1;

	switch (cmd) {
	case SPM_ARGS_SPMFW_IDX:
		__spmfw_idx = x2;
		is_ext_buck = x3;
		break;
	case SPM_ARGS_SPMFW_INIT:
#if !defined(MTK_FPGA_EARLY_PORTING)
		spm_config_spmfw_base(x2, x3);
		spm_load_pcm_firmware();
#endif /* MTK_FPGA_EARLY_PORTING */
		break;
	case SPM_ARGS_SUSPEND:
		spm_suspend();
		break;
	case SPM_ARGS_SUSPEND_FINISH:
		spm_suspend_finish();
		break;
	case SPM_ARGS_SODI:
		spm_sodi();
		break;
	case SPM_ARGS_SODI_FINISH:
		spm_sodi_finish();
		break;
	case SPM_ARGS_DPIDLE:
		spm_dpidle();
		break;
	case SPM_ARGS_DPIDLE_FINISH:
		spm_dpidle_finish();
		break;
	default:
		break;
	}
}

void spm_register_init(void)
{
	uint32_t spm_clk_con;

	/* enable register control */
	mmio_write_32(POWERON_CONFIG_EN,
		      SPM_REGWR_CFG_KEY | BCLK_CG_EN_LSB | MD_BCLK_CG_EN_LSB |
		      DISP_MTCMOS_EN_LSB | AUDIO_MTCMOS_EN_LSB);

	/* init power control register */
	mmio_write_32(SPM_POWER_ON_VAL1, POWER_ON_VAL1_DEF);
	mmio_write_32(PCM_PWR_IO_EN, 0);

	/* reset PCM */
	mmio_write_32(PCM_CON0, SPM_REGWR_CFG_KEY | PCM_CK_EN_LSB | PCM_SW_RESET_LSB);
	mmio_write_32(PCM_CON0, SPM_REGWR_CFG_KEY | PCM_CK_EN_LSB);
	if ((mmio_read_32(PCM_FSM_STA) & 0x7fffff) != PCM_FSM_STA_DEF)
		ERROR("PCM reset failed\n");

	/* init PCM control register */
	mmio_write_32(PCM_CON0, SPM_REGWR_CFG_KEY | PCM_CK_EN_LSB | EN_IM_SLEEP_DVS_LSB);
	mmio_write_32(PCM_CON1, SPM_REGWR_CFG_KEY | EVENT_LOCK_EN_LSB |
		      SPM_SRAM_ISOINT_B_LSB | MIF_APBEN_LSB | SCP_APB_INTERNAL_EN_LSB);
	mmio_write_32(PCM_IM_PTR, 0);
	mmio_write_32(PCM_IM_LEN, 0);

	spm_clk_con = SYSCLK1_EN_CTRL | SYS_SETTLE_SEL_LSB |
		      SPM_LOCK_INFRA_DCM_LSB | EXT_SRCCLKEN_MASK |
		      CLKSQ1_SEL_CTRL_LSB | SRCLKEN0_EN_LSB |
		      SCP_DCM_EN_LSB | SYSCLK1_SRC_MASK_B;
	mmio_write_32(SPM_CLK_CON, spm_clk_con);

	/* clean wakeup event raw status */
	mmio_write_32(SPM_WAKEUP_EVENT_MASK, SPM_WAKEUP_EVENT_MASK_DEF);

	/* clean ISR status */
	mmio_write_32(SPM_IRQ_MASK, ISRM_ALL);
	mmio_write_32(SPM_IRQ_STA, ISRC_ALL);
	mmio_write_32(SPM_SWINT_CLR, PCM_SW_INT_ALL);

	/* init r7 with POWER_ON_VAL1 */
	mmio_write_32(PCM_REG_DATA_INI, mmio_read_32(SPM_POWER_ON_VAL1));
	mmio_write_32(PCM_PWR_IO_EN, PCM_RF_SYNC_R7);
	mmio_write_32(PCM_PWR_IO_EN, 0);

	mmio_write_32(DDR_EN_DBC_LEN,
		      MD_DDR_EN_0_DBC_LEN |
		      MD_DDR_EN_1_DBC_LEN |
		      CONN_DDR_EN_DBC_LEN);
	mmio_write_32(SPM_PC_TRACE_CON, 0x1 | SPM_PC_TRACE_HW_EN_LSB);
}

void spm_config_spmfw_base(uint64_t addr, uint64_t size)
{
	spm_base_addr = addr;
	spm_base_size = size;

	INFO("#@# %s(%d) spm_base_addr 0x%llx, spm_base_size 0x%llx\n", __func__, __LINE__,
			spm_base_addr, spm_base_size);


	mmap_add_dynamic_region((addr & ~(PAGE_SIZE_MASK)),	(addr & ~(PAGE_SIZE_MASK)),
			ALIGN(size, (PAGE_SIZE_MASK)), MT_MEMORY | MT_RW | MT_SECURE);

}

void spm_boot_init(void)
{
	spm_lock_init();
	spm_add_dram_type_control(__spm_suspend.pwrctrl, 1); /* suspend */
	spm_add_dram_type_control(__spm_dpidle.pwrctrl, 0);  /* dpidle */
	spm_add_dram_type_control(__spm_sodi.pwrctrl, 0);    /* sodi */
	spm_add_dram_type_control(__spm_vcorefs.pwrctrl, 0); /* vcore dvfs */
	spm_register_init();
	__spm_reset_and_init_pcm(&suspend_pcm);
	__spm_kick_im_to_fetch(&suspend_pcm);
	__spm_init_pcm_register();
	__spm_init_event_vector(&suspend_pcm);
	mmio_write_32(SPM_SW_FLAG, SPM_FLAG_RUN_COMMON_SCENARIO);
	INFO("%s: SPM_SW_FLAG = 0x%x\n", spm_get_firmware_version(), spm_read(SPM_SW_FLAG));
	__spm_kick_pcm_to_run();
	mt_spm_pmic_wrap_set_phase(PMIC_WRAP_PHASE_ALLINONE);
}

void spm_legacy_sleep_wfi(uint64_t x1, uint64_t x2, uint64_t x3)
{
	unsigned long mpidr;

	/* Enable the gic cpu interface */
	gic_cpuif_init();

	/* Get the mpidr for this cpu */
	mpidr = read_mpidr_el1();

	/*
	 * Enter standby state. dsb is good practice before using wfi
	 * to enter low power states.
	 */
	isb();
	dsb();

	/* Disable coherency if this cluster is to be turned off */

	plat_mtk_cci_disable();
	disable_scu(mpidr);

	wfi();

	/* Enable coherency if this cluster was off */
	enable_scu(mpidr);
	plat_mtk_cci_enable();
}

void spm_set_bootaddr(unsigned long bootaddr)
{
	/* initialize core4~7 boot entry address */
	mmio_write_32(SW2SPM_MAILBOX_3, bootaddr);
}
